#include <windows.h>
#include <math.h>
#include <stdio.h>
#include "resource.h"
#include "..\..\..\common\getimage.h"
#include "..\..\..\common\StringVector.h"
#include "..\..\..\common\AviFile.h"
#include "..\..\..\common\CWaterRoutine.h"
#include "..\..\..\common\FolderBrowser.h"
#include "..\..\..\common\listbox.h"
#include "..\..\..\common\parallell.h"

double pi=3.14159265;
int g_MaxIter=-1;
double g_nColorDiv=1;
int g_nColorMethod=0;
int g_nMinIter=0;
int g_nMaxIter=1;
double g_nColorDivOffs=0;
BOOL bReadColorDiv=TRUE;
int g_nZoomSize=2;
double g_nColOffs=0;
double g_nColOffsOffs=0;
int g_nMaxFrames=2000;
int g_nX = 960;
int g_bTest=0;
HWND g_hwPreview=NULL;
double g_nRotate=0;
BOOL g_bRotate=FALSE;
double g_nRotateOffs=0;
char g_szFind[256];
char g_szFontName[100]="Courier New";
BOOL g_bZoomText=1;
int g_nFPS=30;
int g_nBits=24;
BOOL g_bTrans=TRUE;
BOOL g_bFixed=FALSE;
BOOL g_bSMD=FALSE;
BOOL g_bLeftScroll=FALSE;
BOOL g_3_4=FALSE;
CStringTable g_stParts, g_stRotate, g_stCycle, g_stDivision, g_stNOC;
HANDLE g_hMutex=NULL;
BOOL g_bReadColors=TRUE;
int g_nParts=0;
BOOL g_bWaves=FALSE;
#define IMG_COMBINE 6
int g_nImg_Combine=4;

#define WAVE_COLORS_NUM 61
struct WAVE_COLORS
{
	int nType;
	int nPeriod;
	int nStart;
	BOOL bLast;
	COLORREF col;
	int percent;
}g_WaveColors[WAVE_COLORS_NUM], g_LongWaveColors[WAVE_COLORS_NUM];
struct WAVE_INTERVALS
{
	int nStart;
	double nMinus;
	BOOL bLast;
}g_WaveIntervals[WAVE_COLORS_NUM];

int SaveJPG(char *szFileName, char *Data, int nHeight, int nWidth, int nColors, int nQuality);
int SaveJpg(char *szFileName,HBITMAP bmBmp,int nQuality)
{
	int row, height, nXStart, nYStart;
	BYTE *lpBits, *lpJeg;
	BITMAPINFOHEADER bmi={sizeof(BITMAPINFOHEADER)};
	HDC hDC = GetDC(NULL);
	if(!GetDIBits(hDC,bmBmp,0,0,NULL,(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);
	bmi.biCompression=bmi.biClrUsed=bmi.biClrImportant=0;
	bmi.biBitCount = 24;
	row = ((((bmi.biWidth*(DWORD)bmi.biBitCount)+31)&~31) >> 3);
	height = bmi.biHeight*3;
	bmi.biSizeImage=row*bmi.biHeight;
	lpBits = new BYTE[bmi.biSizeImage];
	lpJeg = new BYTE[bmi.biSizeImage];
	if(!GetDIBits(hDC,bmBmp,0,bmi.biHeight,lpBits,
			(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);

	int nPos=0;
	for(nYStart=bmi.biHeight;nYStart>=0;nYStart--){
		for(nXStart=0;nXStart<bmi.biWidth;nXStart++){
			if(nXStart*3 + nYStart*row + 2 < (int)bmi.biSizeImage){
				lpJeg[nPos++]=lpBits[nXStart*3 + nYStart*row + 2];
				lpJeg[nPos++]=lpBits[nXStart*3 + nYStart*row + 1];
				lpJeg[nPos++]=lpBits[nXStart*3 + nYStart*row];
			}
		}
	}
	int nRet = SaveJPG(szFileName,(char*)lpJeg,bmi.biHeight,bmi.biWidth,3,nQuality);
	delete [] lpJeg;
	delete [] lpBits;
	ReleaseDC(NULL,hDC);
	return nRet;
}

HBITMAP ShrinkBitmap2(HBITMAP bmSrc,int nNewWidth,int nNewHeight,BOOL bHalfTone=TRUE)
{
	HDC hDC = GetDC(NULL);
	BITMAP bm;
	GetObject(bmSrc,sizeof(BITMAP),&bm);
	HDC dcSrc = CreateCompatibleDC(hDC);
	HBITMAP bmOldSrc = (HBITMAP)SelectObject(dcSrc,bmSrc);
	HDC dcDst = CreateCompatibleDC(hDC);
	HBITMAP bmDst = CreateCompatibleBitmap(hDC,nNewWidth,nNewHeight);
	HBITMAP bmOldDst = (HBITMAP)SelectObject(dcDst,bmDst);
	if(bHalfTone)
		SetStretchBltMode(dcDst,HALFTONE);
	else
		SetStretchBltMode(dcDst,COLORONCOLOR);
	StretchBlt(dcDst,0,0,nNewWidth,nNewHeight,dcSrc,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
	SelectObject(dcDst,bmOldDst);
	SelectObject(dcSrc,bmOldSrc);
	DeleteDC(dcDst);
	DeleteDC(dcSrc);
	ReleaseDC(NULL,hDC);
	return bmDst;
}
void AlphaBlt(HBITMAP bmDst,int x, int y, int w, int h, HBITMAP bmSrc, int sx, int sy, int nPercentage,COLORREF transparent)
{
	int row, rowSrc;
	BYTE *lpBits, *lpBitsSrc;
	HDC dc = GetDC(NULL);
	BITMAPINFOHEADER bmi={sizeof(BITMAPINFOHEADER)};
	BITMAPINFOHEADER bmiSrc={sizeof(BITMAPINFOHEADER)};
	if(!GetDIBits(dc,bmSrc,0,0,NULL,(LPBITMAPINFO)&bmiSrc,DIB_RGB_COLORS))
		Beep(1000,10);
	bmiSrc.biCompression=bmiSrc.biClrUsed=bmiSrc.biClrImportant=0;
	bmiSrc.biBitCount = 24;
	rowSrc = ((((bmiSrc.biWidth*(DWORD)bmiSrc.biBitCount)+31)&~31) >> 3);
	bmiSrc.biSizeImage=rowSrc*bmiSrc.biHeight;
	lpBitsSrc = new BYTE[bmiSrc.biSizeImage];
	if(!GetDIBits(dc,bmSrc,0,bmiSrc.biHeight,lpBitsSrc,
			(LPBITMAPINFO)&bmiSrc,DIB_RGB_COLORS))
		Beep(1000,10);

	if(!GetDIBits(dc,bmDst,0,0,NULL,(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);
	bmi.biCompression=bmi.biClrUsed=bmi.biClrImportant=0;
	bmi.biBitCount = 24;
	row = ((((bmi.biWidth*(DWORD)bmi.biBitCount)+31)&~31) >> 3);
	bmi.biSizeImage=row*bmi.biHeight;
	lpBits = new BYTE[bmi.biSizeImage];
	if(!GetDIBits(dc,bmDst,0,bmi.biHeight,lpBits,
			(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);
	int nXStart, nYStart;
	for(nXStart = 0;nXStart<w;nXStart++){
		for(nYStart = 0;nYStart<h;nYStart++){
			if((nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row + 2 < (int)bmi.biSizeImage && (nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc + 2 < (int)bmiSrc.biSizeImage){
				if(transparent==RGB(lpBitsSrc[(nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc + 2],lpBitsSrc[(nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc + 1],lpBitsSrc[(nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc]))
					continue;
				lpBits[(nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row] = (nPercentage*lpBitsSrc[(nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc] + (100-nPercentage)*lpBits[(nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row])/100;
				lpBits[(nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row + 1] = (nPercentage*lpBitsSrc[(nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc + 1] + (100-nPercentage)*lpBits[(nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row + 1])/100;
				lpBits[(nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row + 2] = (nPercentage*lpBitsSrc[(nXStart+sx)*3 + (bmiSrc.biHeight-(nYStart+sy)-1)*rowSrc + 2] + (100-nPercentage)*lpBits[(nXStart+x)*3 + (bmi.biHeight-(nYStart+y)-1)*row + 2])/100;
			}
		}
	}
	if(!SetDIBits(dc,bmDst,0,bmi.biHeight,lpBits,
			(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);
	delete [] lpBits;
	delete [] lpBitsSrc;
	ReleaseDC(NULL,dc);
}
void SetZoomText(HBITMAP bmBmp,char *szZ)
{
	HDC dc = GetDC(NULL);
	HDC dcBmp = CreateCompatibleDC(dc);
	HBITMAP bmOld = (HBITMAP)SelectObject(dcBmp,bmBmp);
	SIZE sc;
	HFONT hFont = CreateFont(-60,0,0,0,0,0,0,0,0,0,0,0,0,g_szFontName);
	//HFONT hFont = CreateFont(-45,0,0,0,0,0,0,0,0,0,0,0,0,g_szFontName);
	HFONT hfOld = (HFONT)SelectObject(dc,hFont);
	GetTextExtentPoint32(dc,szZ,strlen(szZ),&sc);
	SelectObject(dc,hfOld);
	sc.cx+=6;
	sc.cy+=6;
	HBITMAP bmText = CreateCompatibleBitmap(dc,sc.cx,sc.cy);
	HDC dcText = CreateCompatibleDC(dc);
	HBITMAP bmOldText = (HBITMAP)SelectObject(dcText,bmText);
	RECT r={0,0,sc.cx,sc.cy};
	HBRUSH br = CreateSolidBrush(RGB(0,0,255));
	FillRect(dcText,&r,br);
	DeleteObject(br);
	SetBkMode(dcText,TRANSPARENT);
	SetTextAlign(dcText,TA_TOP|TA_LEFT);
	hfOld = (HFONT)SelectObject(dcText,hFont);
	SetTextColor(dcText,RGB(0,0,0));
	TextOut(dcText,8,8,szZ,strlen(szZ));
	SetTextColor(dcText,RGB(255,192,255));
	TextOut(dcText,2,2,szZ,strlen(szZ));
	SelectObject(dcText,hfOld);
	DeleteObject(hFont);
	SelectObject(dcText,bmOldText);
	BITMAP bm;
	GetObject(bmBmp,sizeof(BITMAP),&bm);
	HBITMAP bmScaledText = ShrinkBitmap2(bmText,sc.cx*bm.bmWidth/1920,sc.cy*bm.bmWidth/1920);
	SelectObject(dcBmp,bmOld);
	AlphaBlt(bmBmp,10*bm.bmWidth/1920,10*bm.bmWidth/1920,sc.cx*bm.bmWidth/1920,sc.cy*bm.bmWidth/1920,bmScaledText,0,0,70,RGB(0,0,255));
	DeleteObject(bmText);
	DeleteObject(bmScaledText);
	DeleteDC(dcText);

	DeleteDC(dcBmp);
	ReleaseDC(NULL,dc);
}
BOOL g_bRunning=FALSE;
BOOL g_bStop=FALSE;

HBITMAP CopyBitmap(HBITMAP bmBmp,int nWidth,int nHeight)
{
	HDC hDC = GetDC(NULL);
	HBITMAP bmRet = CreateCompatibleBitmap(hDC,nWidth,nHeight);
	HDC dcRet = CreateCompatibleDC(hDC);
	HBITMAP bmOldRet = (HBITMAP)SelectObject(dcRet,bmRet);
	HDC dcBmp = CreateCompatibleDC(hDC);
	HBITMAP bmOldBmp = (HBITMAP)SelectObject(dcBmp,bmBmp);
	BitBlt(dcRet,0,0,nWidth,nHeight,dcBmp,0,0,SRCCOPY);
	SelectObject(dcRet,bmOldRet);
	SelectObject(dcBmp,bmOldBmp);
	DeleteDC(dcRet);
	DeleteDC(dcBmp);
	ReleaseDC(NULL,hDC);
	return bmRet;
}
void SwapColors(HBITMAP bmSrc,int nFrom, int nTo)
{
	if(nFrom>2)
		nFrom=2;
	if(nFrom<0)
		nFrom=0;
	if(nTo>2)
		nTo=2;
	if(nTo<0)
		nTo=0;
	int rowSrc;
	BYTE *lpBitsSrc;
	HDC dc = GetDC(NULL);
	BITMAPINFOHEADER bmiSrc={sizeof(BITMAPINFOHEADER)};
	if(!GetDIBits(dc,bmSrc,0,0,NULL,(LPBITMAPINFO)&bmiSrc,DIB_RGB_COLORS))
		Beep(1000,10);
	bmiSrc.biCompression=bmiSrc.biClrUsed=bmiSrc.biClrImportant=0;
	bmiSrc.biBitCount = 24;
	rowSrc = ((((bmiSrc.biWidth*(DWORD)bmiSrc.biBitCount)+31)&~31) >> 3);
	bmiSrc.biSizeImage=rowSrc*bmiSrc.biHeight;
	lpBitsSrc = new BYTE[bmiSrc.biSizeImage];
	if(!GetDIBits(dc,bmSrc,0,bmiSrc.biHeight,lpBitsSrc,
			(LPBITMAPINFO)&bmiSrc,DIB_RGB_COLORS))
		Beep(1000,10);

	int nXStart, nYStart;
	for(nXStart = 0;nXStart<bmiSrc.biWidth;nXStart++){
		for(nYStart = 0;nYStart<bmiSrc.biHeight;nYStart++){
			if(nXStart*3 + (bmiSrc.biHeight-nYStart-1)*rowSrc + 2 < (int)bmiSrc.biSizeImage){
				char c = lpBitsSrc[nXStart*3 + (bmiSrc.biHeight-nYStart-1)*rowSrc+nFrom];
				lpBitsSrc[nXStart*3 + (bmiSrc.biHeight-nYStart-1)*rowSrc + nFrom] = lpBitsSrc[nXStart*3 + (bmiSrc.biHeight-nYStart-1)*rowSrc + nTo];
				lpBitsSrc[nXStart*3 + (bmiSrc.biHeight-nYStart-1)*rowSrc + nTo] = c;
			}
		}
	}
	if(!SetDIBits(dc,bmSrc,0,bmiSrc.biHeight,lpBitsSrc,
			(LPBITMAPINFO)&bmiSrc,DIB_RGB_COLORS))
		Beep(1000,10);
	ReleaseDC(NULL,dc);
	delete [] lpBitsSrc;
}
void RotateImage(HBITMAP bmBkg,HBITMAP bmBkgDraw,POINT pm,double nDegree)
{

	double s = sin(((double)nDegree*3.14159)/(double)180);
	double c = cos(((double)nDegree*3.14159)/(double)180);
	HDC hDC = GetDC(NULL);
	BYTE *lpBits=NULL;
	int nBits=0;
	BITMAPINFOHEADER bmi={sizeof(BITMAPINFOHEADER)};
	int row;
	GetDIBits(hDC,bmBkg,0,0,NULL,(LPBITMAPINFO)&bmi,DIB_RGB_COLORS);
	bmi.biCompression=bmi.biClrUsed=bmi.biClrImportant=0;
	bmi.biBitCount = 24;
	row = ((((bmi.biWidth*(DWORD)bmi.biBitCount)+31)&~31) >> 3);
	bmi.biSizeImage=row*bmi.biHeight;
	BYTE *lpOrgBits = new BYTE[bmi.biSizeImage];
	GetDIBits(hDC,bmBkg,0,bmi.biHeight,lpOrgBits,
			(LPBITMAPINFO)&bmi,DIB_RGB_COLORS);

	BITMAPINFOHEADER bmiDraw={sizeof(BITMAPINFOHEADER)};
	GetDIBits(hDC,bmBkgDraw,0,0,NULL,(LPBITMAPINFO)&bmiDraw,DIB_RGB_COLORS);
	bmiDraw.biCompression=bmiDraw.biClrUsed=bmiDraw.biClrImportant=0;
	bmiDraw.biBitCount = 24;
	int rowDraw = ((((bmiDraw.biWidth*(DWORD)bmiDraw.biBitCount)+31)&~31) >> 3);
	bmiDraw.biSizeImage=rowDraw*bmiDraw.biHeight;
	lpBits = new BYTE[bmiDraw.biSizeImage];
	memset(lpBits,50,bmiDraw.biSizeImage);

	POINT p1, p2;
	for(p1.y=0;p1.y<bmiDraw.biHeight;p1.y++){
		for(p1.x=0;p1.x<bmiDraw.biWidth;p1.x++){
			lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw] = lpOrgBits[0];
			lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw+1] = lpOrgBits[1];
			lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw+2] = lpOrgBits[2];

			p2 = p1;
			p2.x+=pm.x/2;
			p2.y+=pm.y/2;

			double dx = (double)pm.x + (double)(p2.x-pm.x)*c
				+ (double)(p2.y-pm.y)*s;
			double dy = (double)pm.y + (double)(p2.y-pm.y)*c
				- (double)(p2.x-pm.x)*s;
			if(dx<=-1 || dy<=-1)
				continue;
			if(dx<0)
				dx=0;
			if(dy<0)
				dy=0;
			p2.x = (int)dx;
			p2.y = (int)dy;
			if(p2.x<0 || p2.x>=bmi.biWidth || p2.y<0 || p2.y>=bmi.biHeight)
				continue;
			int R, Rx, Ry, Rz, G, Gx, Gy, Gz, B, Bx, By, Bz;
			double X, Xn, Y, Yn, Z, Zn;
			Xn = dx - (int)dx;
			X = 1 - Xn;
			Yn = dy - (int)dy;
			Y = 1 - Yn;
			Zn = (Xn+Yn)/2;
			Z = 1 - Zn;
			R = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row];
			G = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 1];
			B = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 2];
			p2.x++;
			if(p2.x<0 || p2.x>=bmi.biWidth || p2.y<0 || p2.y>=bmi.biHeight){
				Rx = R;
				Gx = G;
				Bx = B;
			}
			else{
				Rx = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row];
				Gx = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 1];
				Bx = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 2];
			}
			p2.x--;
			p2.y++;
			if(p2.x<0 || p2.x>=bmi.biWidth || p2.y<0 || p2.y>=bmi.biHeight){
				Ry = R;
				Gy = G;
				By = B;
			}
			else{
				Ry = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row];
				Gy = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 1];
				By = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 2];
			}
			p2.x++;
			if(p2.x<0 || p2.x>=bmi.biWidth || p2.y<0 || p2.y>=bmi.biHeight){
				Rz = R;
				Gz = G;
				Bz = B;
			}
			else{
				Rz = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row];
				Gz = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 1];
				Bz = lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row + 2];
			}

			R = (int)(((double)R*X + (double)Rx*Xn + (double)R*Y + (double)Ry*Yn + (double)R*Z + (double)Rz*Zn)/3);
			G = (int)(((double)G*X + (double)Gx*Xn + (double)G*Y + (double)Gy*Yn + (double)G*Z + (double)Gz*Zn)/3);
			B = (int)(((double)B*X + (double)Bx*Xn + (double)B*Y + (double)By*Yn + (double)B*Z + (double)Bz*Zn)/3);
			lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw] = R;
			lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw+1] = G;
			lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw+2] = B;

//			memcpy(&lpBits[p1.x*3 + (bmiDraw.biHeight-p1.y-1)*rowDraw],&lpOrgBits[p2.x*3 + (bmi.biHeight-p2.y-1)*row],3);
		}
	}
	SetDIBits(hDC,bmBkgDraw,0,bmiDraw.biHeight,lpBits,
			(LPBITMAPINFO)&bmiDraw,DIB_RGB_COLORS);
	delete lpBits;
	delete lpOrgBits;
	ReleaseDC(NULL,hDC);
}
void ShowPreview(HBITMAP bmStore)
{
	if(g_hwPreview){
		BITMAP bm;
		GetObject(bmStore,sizeof(BITMAP),&bm);
		RECT r;
		GetClientRect(g_hwPreview,&r);
		HDC dcPreview = GetDC(g_hwPreview);
		SetStretchBltMode(dcPreview,HALFTONE);
		HDC dcStore = CreateCompatibleDC(dcPreview);
		HBITMAP bmOld = (HBITMAP)SelectObject(dcStore,bmStore);
		StretchBlt(dcPreview,0,0,r.right,r.bottom,dcStore,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
		SelectObject(dcStore,bmOld);
		DeleteDC(dcStore);
		ReleaseDC(g_hwPreview,dcPreview);
	}
}
CAviFile *AppendFrame(CAviFile *pAvi,HBITMAP bmStore,int &nFramesNum,int nMaxFrames,int &nMovieNum,char *szMovie,CWaterRoutine &wr,char *szZoomText,BOOL bApplyWater)
{
	if(bApplyWater){
		BITMAP bm;
		GetObject(bmStore,sizeof(BITMAP),&bm);
		HBITMAP bmWater = CopyBitmap(bmStore,bm.bmWidth+1,bm.bmHeight);
		HBITMAP bmTmp;
		wr.Render(bmWater,bmTmp);
		DeleteObject(bmWater);
		bmWater = CopyBitmap(bmTmp,bm.bmWidth,bm.bmHeight);
		DeleteObject(bmTmp);
		ShowPreview(bmWater);
		if(!g_bTest)
			pAvi->AppendNewFrame(bmWater);
		DeleteObject(bmWater);
	}
	else if(g_bRotate){
		HDC hDC = GetDC(NULL);
		BITMAP bm;
		GetObject(bmStore,sizeof(BITMAP),&bm);
		HBITMAP bmR = CreateCompatibleBitmap(hDC,bm.bmWidth/2,bm.bmHeight/2);
		POINT pm = {bm.bmWidth/2,bm.bmHeight/2};
		//pm.x=100;
		//pm.y=100;
		if(g_nRotate)
			RotateImage(bmStore,bmR,pm,g_nRotate);
		else{
			HDC dcStore = CreateCompatibleDC(hDC);
			HDC dcR = CreateCompatibleDC(hDC);
			HBITMAP bmOldStore = (HBITMAP)SelectObject(dcStore,bmStore);
			HBITMAP bmOldR = (HBITMAP)SelectObject(dcR,bmR);
			BitBlt(dcR,0,0,bm.bmWidth/2,bm.bmHeight/2,dcStore,bm.bmWidth/4,bm.bmHeight/4,SRCCOPY);
			SelectObject(dcStore,bmOldStore);
			SelectObject(dcR,bmOldR);
			DeleteDC(dcStore);
			DeleteDC(dcR);
		}
		if(g_bZoomText)
			SetZoomText(bmR,szZoomText);
		ShowPreview(bmR);
		if(!g_bTest)
			pAvi->AppendNewFrame(bmR);
		DeleteObject(bmR);
		g_nRotate+=g_nRotateOffs;
		if(g_nRotate>360)
			g_nRotate-=360;
		else if(g_nRotate<-360)
			g_nRotate+=360;
		ReleaseDC(NULL,hDC);
	}
	else{
		//SwapColors(bmStore,0,2);
		ShowPreview(bmStore);
		if(!g_bTest){
			if(g_3_4){
				BITMAP bm;
				GetObject(bmStore,sizeof(BITMAP),&bm);
				HDC hDC = GetDC(NULL);
				HDC dcStore = CreateCompatibleDC(hDC);
				HDC dcAdd = CreateCompatibleDC(hDC);
				HBITMAP bmOldStore = (HBITMAP)SelectObject(dcStore,bmStore);
				HBITMAP bmAdd = CreateCompatibleBitmap(hDC,bm.bmHeight*4/3,bm.bmHeight);
				HBITMAP bmOldAdd = (HBITMAP)SelectObject(dcStore,bmAdd);
				BitBlt(dcAdd,0,0,bm.bmHeight*4/3,bm.bmHeight,dcStore,(bm.bmWidth - bm.bmHeight*4/3)/2,0,SRCCOPY);
				SelectObject(dcStore,bmOldStore);
				SelectObject(dcAdd,bmOldAdd);
				DeleteDC(dcStore);
				DeleteDC(dcAdd);
				ReleaseDC(NULL,hDC);
				pAvi->AppendNewFrame(bmAdd);
				DeleteObject(bmAdd);
			}
			else
				pAvi->AppendNewFrame(bmStore);
		}
	}
	nFramesNum++;
	if(nFramesNum>=nMaxFrames){
		nFramesNum=0;
		CAviFile *pOld = pAvi;
		nMovieNum++;
		wsprintf(strrchr(szMovie,'\\')+1,"film_%02d.avi",nMovieNum);
		pAvi = new CAviFile(szMovie,g_nBits,g_nFPS,1,100,pOld->GetCodec());
		delete pOld;
	}
	return pAvi;
}
void FixDiagonalGlitch(HBITMAP bmBmp)
{
	BITMAP bm;
	GetObject(bmBmp,sizeof(BITMAP),&bm);
	int nMX = bm.bmWidth/2;
	int nMY = bm.bmHeight/2;
	int i;
	HDC hDC = GetDC(NULL);
	COLORREF col=0;
	for(i=0;nMY-i>=0 && nMY+i<bm.bmHeight;i++){
		col = GetPixelDIB(hDC,bmBmp,nMX-i+1,nMY-i);
		SetPixelDIB(hDC,bmBmp,nMX-i,nMY-i,col,FALSE);
		col = GetPixelDIB(hDC,bmBmp,nMX+i-1,nMY-i);
		SetPixelDIB(hDC,bmBmp,nMX+i,nMY-i,col,FALSE);
		col = GetPixelDIB(hDC,bmBmp,nMX-i-1,nMY+i);
		SetPixelDIB(hDC,bmBmp,nMX-i,nMY+i,col,FALSE);
		col = GetPixelDIB(hDC,bmBmp,nMX+i+1,nMY+i);
		SetPixelDIB(hDC,bmBmp,nMX+i,nMY+i,col,FALSE);

		col = GetPixelDIB(hDC,bmBmp,nMX-1,nMY+i);
		SetPixelDIB(hDC,bmBmp,nMX,nMY+i,col,FALSE);
		SetPixelDIB(hDC,bmBmp,nMX+1,nMY+i,col,FALSE);
		col = GetPixelDIB(hDC,bmBmp,nMX-1,nMY-i);
		SetPixelDIB(hDC,bmBmp,nMX,nMY-i,col,FALSE);
		SetPixelDIB(hDC,bmBmp,nMX+1,nMY-i,col,FALSE);
	}
	GetPixelDIB(NULL,NULL,0,0);
	SetPixelDIB(hDC,bmBmp,0,0,0,TRUE);
	ReleaseDC(NULL,hDC);
}
void CreateMap(CStringTable &stMap,int w, int h)
{
	int a, b;
	stMap.Reset();
	for(a=0;a<h;a++){
		stMap.AddRow();
		for(b=0;b<w;b++)
			stMap.AddString(stMap.GetCount()-1,"0");
	}
}

void LoadMap(CStringTable &stMap,char *szFile)
{
	char szMap[256];
	strcpy(szMap,szFile);
	char *e = strrchr(szMap,'.');
	if(e)
		strcpy(e,".krm");
	DWORD dw;
	HANDLE hFile = CreateFile(szMap,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	int nLen = GetFileSize(hFile,NULL);
	char *szData = new char[nLen+1];
	ReadFile(hFile,szData,nLen,&dw,NULL);
	CloseHandle(hFile);
	szData[nLen]=0;
	stMap.Reset();
	if(!strcmp(stMap[stMap.GetCount()-1][0],"Colors:"))
		stMap.DeleteRow(stMap.GetCount()-1);
	stMap.SplitString(szData," ","\r\n");
}
void StretchMap(CStringTable &stDst,int dx, int dy, int dw, int dh, CStringTable &stSrc,int sx,int sy, int sw,int sh)
{
	double dsw = (double)sw/(double)dw;
	double dsh = (double)sh/(double)dh;
	int x, y, scx, scy, snx, sny;
	for(x=dx;x<dw-dx;x++){
		scx = sx+x*dsw;
		if(scx>stSrc[0].GetCount())
			break;
		snx = sx+(x+1)*dsw+2;
		if(snx>stSrc[0].GetCount())
			snx=stSrc[0].GetCount();
		if(scx==snx)
			snx=scx+1;
		for(y=dy;y<dh-dy;y++){
			scy = sy+y*dsh;
			if(scy>stSrc.GetCount())
				break;
			sny = sy+(y+1)*dsh+2;
			if(sny>stSrc.GetCount())
				sny=stSrc.GetCount();
			if(scy==sny)
				sny=scy+1;

			int a, b;
			int nAvg=0;
			int nAvgC=0;
			for(a=scx;a<snx;a++)
				for(b=scy;b<sny;b++){
					nAvg+=atoi(stSrc[b][a]);
					nAvgC++;
				}
			nAvg/=(nAvgC?nAvgC:1);
			stDst.SetInt(y,x,nAvg);
		}
	}
}
void SaveMapAndJpeg(CStringTable &stStore,HBITMAP bmStore,int &nMapNum,char *szFile)
{
	char szStore[256];
	nMapNum++;
	wsprintf(szStore,"C:\\pojects\\ltest\\fraktal_sft\\Release\\3DTest\\%05d",nMapNum);
	char *z = strstr(szFile,"_");
	strcat(szStore,z);
	SaveJpg(szStore,bmStore,99);

	strcpy(strrchr(szStore,'.'),".krm");
	DWORD dw;
	HANDLE hFile = CreateFile(szStore,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL);
	char *szData = stStore.ToText(" ");
	WriteFile(hFile,szData,strlen(szData),&dw,NULL);
	CloseHandle(hFile);
	stStore.DeleteToText(szData);

	wsprintf(szStore,"C:\\pojects\\ltest\\fraktal_sft\\Release\\3DTest\\t%05d",nMapNum);
	strcat(szStore,z);
	int nW = stStore[0].GetCount();
	int nH = stStore.GetCount();
	HDC hDC = GetDC(NULL);
	HBITMAP bmBmp = CreateCompatibleBitmap(hDC,nW,nH);
	int x, y;
	for(x=0;x<nW;x++){
		for(y=0;y<nH;y++){
			int nI = atoi(stStore[y][x]);
			COLORREF col = RGB(nI%256,nI%55,nI%121);
			SetPixelDIB(hDC,bmBmp,x,y,col,FALSE);
		}
	}
	SetPixelDIB(hDC,bmBmp,0,0,0,TRUE);
	SaveJpg(szStore,bmBmp,99);
	DeleteObject(bmBmp);
	ReleaseDC(NULL,hDC);

}
struct COLOR14 { unsigned char r,g,b; };
struct BMPS{
	char szFile[256];
	int **ppBits;
	float **ppTrans;
	int nWidth;
	int nHeight;
	int bUsed;
	int nMaxIter;
}g_Bmps[IMG_COMBINE]={0};
COLOR14 cKeys[1024], cPos[1024];

void FillColorTable(int nParts)
{
	int i;
	for(i=0;i<1024;i++){
		double temp = (double)i*(double)nParts/(double)1024;
		int p = (int)temp;
		int pn = (p+1)%nParts;
		temp-=p;
		temp = sin((temp-.5)*pi)/2 + .5;
		cPos[i].r = (unsigned char)(temp*cKeys[pn].r + (1-temp)*cKeys[p].r);
		cPos[i].g = (unsigned char)(temp*cKeys[pn].g + (1-temp)*cKeys[p].g);
		cPos[i].b = (unsigned char)(temp*cKeys[pn].b + (1-temp)*cKeys[p].b);
	}
}
void ToClipboard(char *szRes,HWND hWnd=NULL)
{
	HANDLE hTemp = GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,strlen(szRes)+1);
	char *szTemp = (char*)GlobalLock(hTemp);
	if(hWnd==NULL)
		hWnd = GetDesktopWindow();
	strcpy(szTemp,szRes);
	if(!OpenClipboard(hWnd))
		Beep(1000,100);
	if(!EmptyClipboard())
		Beep(2000,100);
	GlobalUnlock(hTemp);
	if(!SetClipboardData(CF_TEXT,hTemp))
		Beep(3000,100);
	if(!CloseClipboard())
		Beep(400,100);
//	GlobalFree(hTemp);
}
int g_nNextPos=0;
void InitMultiWave()
{
	int i, j;
	for(i=0;i<WAVE_COLORS_NUM;i++){
		if(i==0)
			g_WaveColors[i].nPeriod = 30;
		else
			g_WaveColors[i].nPeriod = g_WaveColors[i-1].nPeriod*5*i;
/*		if(i==3)
			g_WaveColors[i].nPeriod=700;
		if(i==4)
			g_WaveColors[i].nPeriod=800;
		if(i==5)
			g_WaveColors[i].nPeriod=2700;
*/		BOOL bPrime=0;
		while(!bPrime){
			bPrime=1;
			for(j=2;bPrime && j<g_WaveColors[i].nPeriod/2;j++)
				if(g_WaveColors[i].nPeriod%j==0)
					bPrime=0;
			if(!bPrime)
				g_WaveColors[i].nPeriod--;
		}
	}
	char szRes[256];
	*szRes=0;
	for(i=0;i<6;i++)
		wsprintf(szRes+strlen(szRes),"%d - %d\n",i,g_WaveColors[i].nPeriod);
	MessageBox(NULL,szRes,"Res",MB_OK);
}
void HSVToRGB(double hue, double sat, double bri,COLOR14 &cPos)
{
	int i;
	hue*=6;

//	double hue = HSVarr[CP_HUE] * 6.0 / 255.0;
//	double sat = HSVarr[CP_SAT] / 255.0;
//	double bri = HSVarr[CP_BRI] / 255.0;
	
	i = (int)floor(hue);

	double f = (hue) - i;
	if(!(i & 1)) //If i is even (i.e. last bit of 'i' isn't set
		f = 1 - f;
	
	double m = bri * (1 - sat);
	double n = bri * (1 - sat * f);

	bri *= 255.0;
	n *= 255.0;
	m *= 255.0;

	switch (i)
	{
		case 6:
		case 0: cPos.b = (byte)bri;
				cPos.g = (byte)n;
				cPos.r = (byte)m;
				break;
		case 1: cPos.b = (byte)n;
				cPos.g = (byte)bri;
				cPos.r = (byte)m;
				break;
		case 2: cPos.b = (byte)m;
				cPos.g = (byte)bri;
				cPos.r = (byte)n;
				break;
		case 3: cPos.b = (byte)m;
				cPos.g = (byte)n;
				cPos.r = (byte)bri;
				break;
		case 4: cPos.b = (byte)n;
				cPos.g = (byte)m;
				cPos.r = (byte)bri;
				break;
		case 5: cPos.b = (byte)bri;
				cPos.g = (byte)m;
				cPos.r = (byte)n;
	}
}
void MultiWave(BYTE *lpBits, int nIndex, double iteration,double original)
{
	int i;
	double nH=0, nS=0, nB=0;
	int nDR=0, nDG=0, nDB=0;
	//iteration+=g_WaveColors[i].nStart;
	for(i=0;i<WAVE_COLORS_NUM && !g_WaveColors[i].bLast;i++){
		double nPeriod;
		nPeriod=g_WaveColors[i].nPeriod;
		double iter=iteration;
/*		while(iter>nPeriod*2){
			iter-=nPeriod*2;
			nPeriod+=nPeriod/100;
		}
*/		//if((int)(iteration/(nPeriod*2))%2==0)
		//	continue;
		//double g = 1 - (cos((pi*(iteration))/nPeriod)/2+.5);
		double g = sin((pi*(iter + g_WaveColors[i].nStart))/nPeriod)/2+.5;
		if(g_WaveColors[i].nType==0){
			nH += g;
			nDR++;
		}
		if(g_WaveColors[i].nType==1){
			nS += g;
			nDG++;
		}
		if(g_WaveColors[i].nType==2){
			nB += g;
			nDB++;
		}
	}

	if(nDR)
		nH/=nDR;
	else
		nH=.5;

	if(nDG)
		nS/=nDG;
	else
		nS=.5;

	if(nDB)
		nB/=nDB;
	else
		nB=.5;
	COLOR14 cPos;
	HSVToRGB(nH,nS,nB,cPos);
	COLOR14 cCols[8]={{0,0,0},{255,255,255},{255,0,255},{255,255,0},{0,255,255},{0,0,255},{0,255,0},{255,0,0}};
	int nCol=0;

	for(i=0;i<WAVE_COLORS_NUM && !g_WaveColors[i].bLast;i++){
		if(g_WaveColors[i].nType!=3)
			continue;
		double nPeriod = g_WaveColors[i].nPeriod;
		if(nPeriod>0 && (int)(original/(nPeriod*2))%2==1){
			double g = sin((pi*(original-nPeriod/2))/nPeriod)/2+.5;
			g*=.8;
			cPos.r = (1-g)*cPos.r + g*cCols[nCol].r;
			cPos.g = (1-g)*cPos.g + g*cCols[nCol].g;
			cPos.b = (1-g)*cPos.b + g*cCols[nCol].b;
		}
		nCol++;
		if(nCol==8)
			nCol=0;
	}

	lpBits[nIndex]     = cPos.r;//+n;
	lpBits[nIndex + 1] = cPos.g;//+n;
	lpBits[nIndex + 2] = cPos.b;//+n;
}
void LongWaves(BYTE *lpBits, int nIndex, double original)
{
	int i;
	for(i=0;i<WAVE_COLORS_NUM && !g_LongWaveColors[i].bLast;i++){
		double nPeriod = g_LongWaveColors[i].nPeriod;
		if(nPeriod>0 && (int)(original/(nPeriod*2))%2==1){
			double g = sin((pi*(original-nPeriod/2))/nPeriod)/2+.5;
			unsigned char *cc = (unsigned char *)&g_LongWaveColors[i].col;
			g*=(double)g_LongWaveColors[i].percent/100;
			lpBits[nIndex]     = (1-g)*lpBits[nIndex]     + g*cc[2];
			lpBits[nIndex + 1] = (1-g)*lpBits[nIndex + 1] + g*cc[1];
			lpBits[nIndex + 2] = (1-g)*lpBits[nIndex + 2] + g*cc[0];
		}
	}
}

HBITMAP GetImageFromMapB(HWND hwStatus,char *szFile,double nColorOffset)
{
	int b;
	int x, y;
/*	char szFile[256];
	strcpy(szFile,szJpeg);
	strcpy(strrchr(szFile,'.'),".kfb");
	BMPS g_Bmps[1]={0};
*/	b=0;
	BOOL bRead=FALSE;
	WaitForSingleObject(g_hMutex,NULL);
	for(b=0;b<IMG_COMBINE;b++)
		if(!stricmp(g_Bmps[b].szFile,szFile))
			break;
	if(b==IMG_COMBINE){
		bRead=TRUE;
		for(b=0;b<IMG_COMBINE;b++)
			if(!*g_Bmps[b].szFile)
				break;
		if(b==IMG_COMBINE){
			do{
				b = g_nNextPos;
				g_nNextPos=(1+g_nNextPos)%IMG_COMBINE;
			}while(g_Bmps[b].bUsed);
		}
		strcpy(g_Bmps[b].szFile,szFile);
	}
	g_Bmps[b].bUsed=TRUE;
	ReleaseMutex(g_hMutex);

	if(bRead){
//		SetWindowText(hwStatus,szFile);
		//HANDLE hFile = CreateFile(szFile,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
		FILE*hFile = fopen(szFile,"rb");
		//if(hFile==INVALID_HANDLE_VALUE){
		if(hFile==NULL){
			ToClipboard(szFile);
			return NULL;
		}
		DWORD dw;
		char szId[3];
		//ReadFile(hFile,szId,3,&dw,NULL);
		fread(szId,1,3,hFile);
		BOOL bNewFormat=FALSE;
		if(strncmp(szId,"KFB",3)){
			//CloseHandle(hFile);
			fclose(hFile);
			*g_Bmps[b].szFile=0;
			g_Bmps[b].bUsed=FALSE;
			return NULL;
		}
		int nH, nW;
		//ReadFile(hFile,&nW,sizeof(int),&dw,NULL);
		fread(&nW,1,sizeof(int),hFile);
		//ReadFile(hFile,&nH,sizeof(int),&dw,NULL);
		fread(&nH,1,sizeof(int),hFile);

		BOOL bAllocate=FALSE;
		if(nH!=g_Bmps[b].nHeight || nW!=g_Bmps[b].nWidth){
			bAllocate=TRUE;
			for(y=0;y<g_Bmps[b].nHeight;y++)
				delete g_Bmps[b].ppBits[y];
			delete g_Bmps[b].ppBits;
			g_Bmps[b].ppBits=NULL;
			for(y=0;y<g_Bmps[b].nHeight;y++)
				delete g_Bmps[b].ppTrans[y];
			delete g_Bmps[b].ppTrans;
			g_Bmps[b].ppTrans=NULL;
			g_Bmps[b].nWidth=nW;
			g_Bmps[b].nHeight=nH;
		}

		if(bAllocate){
			g_Bmps[b].ppBits = new int*[g_Bmps[b].nHeight];
			g_Bmps[b].ppTrans = new float*[g_Bmps[b].nHeight];
		}
		int *pLine = new int[g_Bmps[b].nWidth];
		for(x=0;x<g_Bmps[b].nWidth;x++){
			//ReadFile(hFile,pLine,sizeof(int)*g_Bmps[b].nHeight,&dw,NULL);
			fread(pLine,1,sizeof(int)*g_Bmps[b].nHeight,hFile);
			for(y=0;y<g_Bmps[b].nHeight;y++){
				if(bAllocate && x==0)
					g_Bmps[b].ppBits[y] = new int[g_Bmps[b].nWidth];
				g_Bmps[b].ppBits[y][x] = pLine[y];
			}
		}
		delete [] pLine;
		int nParts;
		int i, p=0;
	WaitForSingleObject(g_hMutex,NULL);
		if(g_bReadColors){
			int nColDiv;
			//ReadFile(hFile,&nColDiv,sizeof(int),&dw,NULL);
			fread(&nColDiv,1,sizeof(int),hFile);
			if(bReadColorDiv)
				g_nColorDiv=nColDiv;
			//ReadFile(hFile,&nParts,sizeof(int),&dw,NULL);
			fread(&nParts,1,sizeof(int),hFile);
			g_nParts = nParts;
			//ReadFile(hFile,cKeys,sizeof(COLOR14)*nParts,&dw,NULL);
			fread(cKeys,1,sizeof(COLOR14)*nParts,hFile);
			FillColorTable(g_nParts);
			g_bReadColors=FALSE;
		}
		else{
			int tmp;
			COLOR14 tmpC[1024];
			//ReadFile(hFile,&tmp,sizeof(int),&dw,NULL);
			fread(&tmp,1,sizeof(int),hFile);
			//ReadFile(hFile,&tmp,sizeof(int),&dw,NULL);
			fread(&tmp,1,sizeof(int),hFile);
			//ReadFile(hFile,tmpC,sizeof(COLOR14)*tmp,&dw,NULL);
			fread(tmpC,1,sizeof(COLOR14)*tmp,hFile);
		}
	ReleaseMutex(g_hMutex);
		int nTest;
		//ReadFile(hFile,&nTest,sizeof(int),&dw,NULL);
		dw=fread(&nTest,1,sizeof(int),hFile);
		if(sizeof(int)==dw)
			g_Bmps[b].nMaxIter = g_MaxIter = nTest;
		else
			g_Bmps[b].nMaxIter = g_MaxIter;
		float *pFLine = new float[g_Bmps[b].nWidth];
		for(x=0;x<g_Bmps[b].nWidth;x++){
			//ReadFile(hFile,pFLine,sizeof(float)*g_Bmps[b].nHeight,&dw,NULL);
			fread(pFLine,1,sizeof(float)*g_Bmps[b].nHeight,hFile);
			for(y=0;y<g_Bmps[b].nHeight;y++){
				if(bAllocate && x==0)
					g_Bmps[b].ppTrans[y] = new float[g_Bmps[b].nWidth];
				g_Bmps[b].ppTrans[y][x] = pFLine[y];
			}
		}
		//CloseHandle(hFile);
		fclose(hFile);
	}
	int nColorDiv = (int)g_nColorDiv;
//	double nColorDiv = g_nColorDiv;
	HDC hDC = GetDC(NULL);
	HBITMAP bmBkg = CreateCompatibleBitmap(hDC,g_Bmps[b].nWidth,g_Bmps[b].nHeight);
	BYTE *lpBits=NULL;
	int nBits=0;
	BITMAPINFOHEADER bmi={sizeof(BITMAPINFOHEADER)};
	int row;
	GetDIBits(hDC,bmBkg,0,0,NULL,(LPBITMAPINFO)&bmi,DIB_RGB_COLORS);
	bmi.biCompression=bmi.biClrUsed=bmi.biClrImportant=0;
	bmi.biBitCount = 24;
	row = ((((bmi.biWidth*(DWORD)bmi.biBitCount)+31)&~31) >> 3);
	bmi.biSizeImage=row*bmi.biHeight;
	lpBits = new BYTE[bmi.biSizeImage];
//	if(nColorOffset<0 && !g_bWaves)
//		nColorOffset+=1024;//*(g_nColorDiv?g_nColorDiv:1);
	for(x=0;x<g_Bmps[b].nWidth;x++){
		for(y=0;y<g_Bmps[b].nHeight;y++){
			int nIndex = x*3 + (bmi.biHeight-1-y)*row;
			
			double it = (double)g_Bmps[b].ppBits[y][x];
			if(!g_bFixed)
				it+=(double)1-(double)g_Bmps[b].ppTrans[y][x];

			if(g_nColorMethod==1)
				it = sqrt(it);
			else if(g_nColorMethod==2)
				it = pow(it,(double)1/(double)3);
			else if(g_nColorMethod==3)
				it = log(it);
			else if(g_nColorMethod==4){
				it = (double)1024 * ((double)it-(double)g_nMinIter) / ((double)g_nMaxIter-(double)g_nMinIter);
				if(it<0)
					it=0;
				if(it>1024)
					it=1024;
			}

			if(g_nColorDiv)
				it/=g_nColorDiv;
			it+=nColorOffset;
			if(!g_bWaves){
				while(it<0)
					it+=1024;
			}
			int nBits = it;
			float fTrans = 1 - (it-nBits);

			if(g_Bmps[b].nMaxIter==g_Bmps[b].ppBits[y][x])
				lpBits[nIndex]=lpBits[nIndex+1]=lpBits[nIndex+2]=0;
			else if(g_bTrans){
				if(g_bWaves)
					MultiWave(lpBits,nIndex,it,(double)g_Bmps[b].ppBits[y][x] + (double)1-(double)g_Bmps[b].ppTrans[y][x]);
				else{
					double g1 = (1-fTrans);
					int col = (nBits)%1024;
					int ncol = (col+1)%1024;
					lpBits[nIndex] = cPos[col].r*fTrans+cPos[ncol].r*g1;
					lpBits[nIndex + 1] = cPos[col].g*fTrans+cPos[ncol].g*g1;
					lpBits[nIndex + 2] = cPos[col].b*fTrans+cPos[ncol].b*g1;
				}
			}
			else{
				int col = nBits%1024;
				if(g_bWaves)
					MultiWave(lpBits,nIndex,(int)it,(double)g_Bmps[b].ppBits[y][x] + (double)1-(double)g_Bmps[b].ppTrans[y][x]);
				else{
					lpBits[nIndex]     = cPos[col].r;//+n;
					lpBits[nIndex + 1] = cPos[col].g;//+n;
					lpBits[nIndex + 2] = cPos[col].b;//+n;
				}
				if(g_bFixed && nColorOffset){
					BYTE Bits[3];
					if(g_bWaves)
						MultiWave(Bits,0,(int)it+1,(double)g_Bmps[b].ppBits[y][x] + (double)1-(double)g_Bmps[b].ppTrans[y][x]);
					else{
						col = (int)(nBits+1)%1024;
						Bits[0] = cPos[col].r;//+n;
						Bits[1] = cPos[col].g;//+n;
						Bits[2] = cPos[col].b;//+n;
					}
					double g = nColorOffset - (int)nColorOffset;
					lpBits[nIndex] = (1-g)*lpBits[nIndex] + g*Bits[0];
					lpBits[nIndex+1] = (1-g)*lpBits[nIndex+1] + g*Bits[1];
					lpBits[nIndex+2] = (1-g)*lpBits[nIndex+2] + g*Bits[2];
				}
			}
			if(g_Bmps[b].nMaxIter!=g_Bmps[b].ppBits[y][x])
				LongWaves(lpBits,nIndex,(double)g_Bmps[b].ppBits[y][x] + (double)1-(double)g_Bmps[b].ppTrans[y][x]);
		}
	}
	if(!SetDIBits(hDC,bmBkg,0,bmi.biHeight,lpBits,
			(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);
	delete lpBits;
	ReleaseDC(NULL,hDC);

	return bmBkg;
}
HBITMAP GetImageFromMap(char *szJpeg,int nColorOffset)
{
	int b;
	int x, y;
	char szFile[256];
	strcpy(szFile,szJpeg);
	strcpy(strrchr(szFile,'.'),".krm");
	for(b=0;b<IMG_COMBINE;b++)
		if(!strcmp(g_Bmps[b].szFile,szFile))
			break;
	if(b==IMG_COMBINE){
		HANDLE hFile = CreateFile(szFile,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
		if(hFile==INVALID_HANDLE_VALUE)
			return NULL;
		for(b=0;b<IMG_COMBINE;b++)
			if(!*g_Bmps[b].szFile)
				break;
		if(b==IMG_COMBINE){
			for(x=0;x<g_Bmps[0].nWidth;x++)
				delete g_Bmps[0].ppBits[x];
			delete g_Bmps[0].ppBits;
			for(b=0;b<4;b++){
				strcpy(g_Bmps[b].szFile,g_Bmps[b+1].szFile);
				g_Bmps[b].ppBits = g_Bmps[b+1].ppBits;
			}
		}
		strcpy(g_Bmps[b].szFile,szFile);
		DWORD dw;
		int nLen = GetFileSize(hFile,NULL);
		char *szData = new char[nLen+1];
		ReadFile(hFile,szData,nLen,&dw,NULL);
		CloseHandle(hFile);
		szData[nLen]=0;
		CStringTable stMap(szData," ","\r\n");
		delete szData;
		CStringTable stColors(stMap[stMap.GetCount()-1][1],"",",");
		stMap.DeleteRow(stMap.GetCount()-1);
		g_Bmps[b].nWidth = stMap[0].GetCount();
		g_Bmps[b].nHeight = stMap.GetCount();
		int nParts = stColors.GetCount()/3;
		if(nParts>1024)
			nParts=1024;
		int i, p=0;
		for(i=0;i<nParts;i++){
			cKeys[i].r = atoi(stColors[i*3][0]);
			cKeys[i].g = atoi(stColors[i*3+1][0]);
			cKeys[i].b = atoi(stColors[i*3+2][0]);
		}
		for(i=0;i<1024;i++){
			int div = 1024/nParts;
			int r=i%div;
			if(r==0 && i)
				p++;
			int pn = p+1;
			if(pn>=nParts)
				pn=1024;
			if(p>=nParts)
				p=1024;
			cPos[i].r = (r*cKeys[pn].r + (div-r)*cKeys[p].r)/div;
			cPos[i].g = (r*cKeys[pn].g + (div-r)*cKeys[p].g)/div;
			cPos[i].b = (r*cKeys[pn].b + (div-r)*cKeys[p].b)/div;
		}
		g_Bmps[b].ppBits = new int*[g_Bmps[b].nWidth];
		for(x=0;x<g_Bmps[b].nWidth;x++){
			g_Bmps[b].ppBits[x] = new int[g_Bmps[b].nHeight];
			for(y=0;y<g_Bmps[b].nHeight;y++){
				g_Bmps[b].ppBits[x][y]=atoi(stMap[y][x]);
			}
		}
	}
	HDC hDC = GetDC(NULL);
	HBITMAP bmBkg = CreateCompatibleBitmap(hDC,g_Bmps[b].nWidth,g_Bmps[b].nHeight);
	BYTE *lpBits=NULL;
	int nBits=0;
	BITMAPINFOHEADER bmi={sizeof(BITMAPINFOHEADER)};
	int row;
	GetDIBits(hDC,bmBkg,0,0,NULL,(LPBITMAPINFO)&bmi,DIB_RGB_COLORS);
	bmi.biCompression=bmi.biClrUsed=bmi.biClrImportant=0;
	bmi.biBitCount = 24;
	row = ((((bmi.biWidth*(DWORD)bmi.biBitCount)+31)&~31) >> 3);
	bmi.biSizeImage=row*bmi.biHeight;
	lpBits = new BYTE[bmi.biSizeImage];
	for(y=0;y<g_Bmps[b].nHeight;y++){
		for(x=0;x<g_Bmps[b].nWidth;x++){
			int nIndex = x*3 + (bmi.biHeight-1-y)*row;
			if(g_MaxIter==g_Bmps[b].ppBits[x][y])
				lpBits[nIndex]=lpBits[nIndex+1]=lpBits[nIndex+2]=0;
			else if(g_nColorDiv>1){
				int nIndex = nColorOffset + g_Bmps[b].ppBits[x][y];
				int col = (int)(nIndex/g_nColorDiv)%1024;
				double g = (double)(nColorOffset + (double)g_Bmps[b].ppBits[x][y])/(double)g_nColorDiv - nIndex/g_nColorDiv;
				g = sin((g-.5)*pi)/2 + .5;
				double g1 = (1-g);
				int ncol = (col+1)%1024;
				lpBits[nIndex] = cPos[col].r*g1+cPos[ncol].r*g;
				lpBits[nIndex + 1] = cPos[col].g*g1+cPos[ncol].g*g;
				lpBits[nIndex + 2] = cPos[col].b*g1+cPos[ncol].b*g;
			}
			else{
				if(nColorOffset){
					int col = (nColorOffset + g_Bmps[b].ppBits[x][y])%1024;
					double g = nColorOffset - (int)nColorOffset;
					g = sin((g-.5)*pi)/2 + .5;
					double g1 = (1-g);
					int ncol = (col+1)%1024;
					lpBits[nIndex] = cPos[col].r*g1+cPos[ncol].r*g;
					lpBits[nIndex + 1] = cPos[col].g*g1+cPos[ncol].g*g;
					lpBits[nIndex + 2] = cPos[col].b*g1+cPos[ncol].b*g;
				}
				else{
					int col = g_Bmps[b].ppBits[x][y]%1024;
					lpBits[nIndex]     = cPos[col].r;//+n;
					lpBits[nIndex + 1] = cPos[col].g;//+n;
					lpBits[nIndex + 2] = cPos[col].b;//+n;
				}
			}
		}
	}
	if(!SetDIBits(hDC,bmBkg,0,bmi.biHeight,lpBits,
			(LPBITMAPINFO)&bmi,DIB_RGB_COLORS))
		Beep(1000,10);
	delete lpBits;
	ReleaseDC(NULL,hDC);
	return bmBkg;
}
struct COMBINE_IMG
{
	char *szFileName;
	double nColorOffset;
	HBITMAP bmPic;
	HWND hwStatus;
};
int CombineImg(COMBINE_IMG *p)
{
	p->bmPic = GetImageFromMapB(p->hwStatus,p->szFileName,p->nColorOffset);
//	if(!p->bmPic)
//		p->bmPic = GetImageFromMap(p->szFileName,p->nColorOffset);
	if(!p->bmPic){
		strcpy(strrchr(p->szFileName,'.'),".jpg");
		p->bmPic = GetImage(p->szFileName);
	}
	return 0;
}
HBITMAP CombineImage(HWND hwStatus,CStringTable &stFiles,int nPos,double nColorOffset,int nZoomSize,int nZoomLevel,int nX, int nY,RECT rBounds)
{
	int k;
	HDC hDC;
	hDC = GetDC(NULL);
	HDC dcFrame = CreateCompatibleDC(hDC);
	SetStretchBltMode(dcFrame,HALFTONE);
	HDC dcPic = CreateCompatibleDC(hDC);
	HBITMAP bmFrame=NULL, bmOldFrame=NULL;
	RECT r;
	CParallell P(
#ifdef _DEBUG
		1
#else
		g_nImg_Combine
#endif
		);
	COMBINE_IMG ci[IMG_COMBINE]={0};
	for(k=0;k<IMG_COMBINE;k++)
		g_Bmps[k].bUsed=0;
	for(k=0;k<g_nImg_Combine && k+nPos<stFiles.GetCount();k++){
		ci[k].szFileName = stFiles[nPos+k][0];
		ci[k].nColorOffset = nColorOffset;
		ci[k].bmPic=NULL;
		ci[k].hwStatus = hwStatus;
		P.AddFunction((LPEXECUTE)CombineImg,&ci[k]);
		if((g_bTest && k>=1) || (g_bLeftScroll && k>=1))
			break;
	}
	if(g_nColorMethod==4){
		for(k=0;k<IMG_COMBINE;k++)
			if(g_Bmps[k].szFile && !stricmp(g_Bmps[k].szFile,ci[0].szFileName))
				break;
		if(k==IMG_COMBINE){
			GetImageFromMapB(hwStatus,ci[0].szFileName,nColorOffset);
			for(k=0;k<IMG_COMBINE;k++)
				if(g_Bmps[k].szFile && !stricmp(g_Bmps[k].szFile,ci[0].szFileName))
					break;
		}
		int x, y;
		int nMaxIter, nMinIter;
		nMaxIter = nMinIter = g_Bmps[k].ppBits[rBounds.top][rBounds.left];
		for(y=rBounds.top;y<rBounds.bottom;y++){
			for(x=rBounds.left;x<rBounds.right;x++){
				if(nMaxIter<g_Bmps[k].ppBits[y][x])
					nMaxIter=g_Bmps[k].ppBits[y][x];
				if(nMinIter>g_Bmps[k].ppBits[y][x])
					nMinIter=g_Bmps[k].ppBits[y][x];
			}
		}
		if(nMinIter<g_nMinIter)
			g_nMinIter--;
		if(nMaxIter<g_nMaxIter)
			g_nMaxIter--;
		for(int qa=0;qa<10;qa++){
			if(g_nMinIter<nMinIter)
				g_nMinIter++;
			if(g_nMaxIter<nMaxIter)
				g_nMaxIter++;
		}
		char szT[256];
		wsprintf(szT,"%d-%d %d-%d",g_nMinIter,g_nMaxIter,nMinIter,nMaxIter);
		SetDlgItemText(GetParent(hwStatus),IDC_EDIT11,szT);
	}
	P.Execute();
	int nLeftPos = nX;
	for(k=0;k<g_nImg_Combine && k+nPos<stFiles.GetCount();k++){
		HBITMAP bmPic = ci[k].bmPic;
//		HBITMAP bmPic = GetImageFromMapB(stFiles[nPos+k][0],nColorOffset);
//		if(!bmPic)
//			bmPic = GetImageFromMap(stFiles[nPos+k][0],nColorOffset);
		if(!bmPic)
			break;
		if(bmFrame==NULL){
			BITMAP bm;
			GetObject(bmPic,sizeof(BITMAP),&bm);
			bmFrame = CreateCompatibleBitmap(hDC,nX*nZoomSize,nY*nZoomSize);
			bmOldFrame = (HBITMAP)SelectObject(dcFrame,bmFrame);
			r.left=r.top=0;
			r.right=nX*nZoomSize;
			r.bottom=nY*nZoomSize;
		}
//		if(nZoomLevel>300)
//			FixDiagonalGlitch(bmPic);
		BITMAP bm2;
		GetObject(bmPic,sizeof(BITMAP),&bm2);
		HBITMAP bmOldPic = (HBITMAP)SelectObject(dcPic,bmPic);
		if(g_bLeftScroll){
			BitBlt(dcFrame,nLeftPos,0,nX,nY,dcPic,0,0,SRCCOPY);
			nLeftPos-=nX;
			if(k>=1)
				break;
		}
		else
			StretchBlt(dcFrame,r.left,r.top,r.right-r.left,r.bottom-r.top,dcPic,0,0,bm2.bmWidth,bm2.bmHeight,SRCCOPY);
		SelectObject(dcPic,bmOldPic);
		DeleteObject(bmPic);

		int offs = (nZoomSize-1)*(r.right-r.left)/(2*nZoomSize);
		r.left+=offs;
		r.right-=offs;
		if(r.right-r.left<10)
			break;
		offs = (nZoomSize-1)*(r.bottom-r.top)/(2*nZoomSize);
		r.top+=offs;
		r.bottom-=offs;
	}
	for(;k<IMG_COMBINE && k+nPos<stFiles.GetCount();k++){
		if(ci[k].bmPic){
			DeleteObject(ci[k].bmPic);
		}
	}
	
	SelectObject(dcFrame,bmOldFrame);
	DeleteDC(dcFrame);
	DeleteDC(dcPic);
	ReleaseDC(NULL,hDC);
	return bmFrame;
}
int WINAPI ThRun(HWND hwStatus)
{
	g_bReadColors=TRUE;
	int nNOC_Offs=0;
	char szMovie[256];
	strcpy(szMovie,g_szFind);
	strcpy(strrchr(szMovie,'\\')+1,"film.avi");

	int nY = 9*g_nX/16;
	WIN32_FIND_DATA fd;
	HANDLE hFind = FindFirstFile(g_szFind,&fd);
	CStringTable stFiles;
	char szStatus[128];
	SetWindowText(hwStatus,"Start");
	if(hFind==INVALID_HANDLE_VALUE){
		SetWindowText(hwStatus,"Invalid Folder");
		return 0;
	}
	do{
		strcpy(strrchr(g_szFind,'\\')+1,fd.cFileName);
		stFiles.AddRow();
		stFiles.AddString(stFiles.GetCount()-1,g_szFind);
		char *e = strrchr(fd.cFileName,'.');
		if(e)
			*e=0;
		stFiles.AddString(stFiles.GetCount()-1,fd.cFileName);
		wsprintf(szStatus,"Browsing:%d",stFiles.GetCount());
		SetWindowText(hwStatus,szStatus);
	}while(FindNextFile(hFind,&fd));
	FindClose(hFind);
	stFiles.BuildHash(1);
/*	strcpy(strrchr(g_szFind,'\\')+1,"*.jpg");
	hFind = FindFirstFile(g_szFind,&fd);
	do{
		char *e = strrchr(fd.cFileName,'.');
		if(e)
			*e=0;
		if(stFiles.FindStringHash(1,fd.cFileName)==-1){
			if(e)
				*e='.';
			strcpy(strrchr(g_szFind,'\\')+1,fd.cFileName);
			stFiles.AddRow();
			stFiles.AddString(stFiles.GetCount()-1,g_szFind);
			wsprintf(szStatus,"Browsing:%d",stFiles.GetCount());
			SetWindowText(hwStatus,szStatus);
		}
	}while(FindNextFile(hFind,&fd));
	FindClose(hFind);
*/	int nMovieNum=0;
	int nFramesNum=0;
	int nMapNum=0;
	int i, k;
	CAviFile *pAvi = new CAviFile(szMovie,g_nBits,g_nFPS,1,100);

	stFiles.M3QSort(0,g_bLeftScroll?0:1);

	for(k=0;k<IMG_COMBINE;k++){
/*		int x;
		for(x=0;x<g_Bmps[k].nWidth;x++)
			delete g_Bmps[k].ppBits[x];
		delete g_Bmps[k].ppBits;
		g_Bmps[k].ppBits=NULL;
		for(x=0;x<g_Bmps[k].nWidth;x++)
			delete g_Bmps[k].ppTrans[x];
		delete g_Bmps[k].ppTrans;
		g_Bmps[k].ppTrans=NULL;
		g_Bmps[k].nWidth=0;
		g_Bmps[k].nHeight=0;
*/		*g_Bmps[k].szFile=0;
		g_Bmps[k].bUsed=0;
	}

	int p = g_stDivision.FindStringHash(0,"0");
	if(p!=-1){
		bReadColorDiv=FALSE;
		g_nColorDiv = atof(g_stDivision[p][1]);
	}
	else
		bReadColorDiv=TRUE;

	p = g_stNOC.FindStringHash(0,"0");
	if(p!=-1)
		nNOC_Offs = atof(g_stNOC[p][1]);
	if(nNOC_Offs){
		g_nParts+=nNOC_Offs;
		if(g_nParts<16)
			g_nParts=16;
		if(g_nParts>1024)
			g_nParts=1024;
		SetDlgItemInt(GetParent(hwStatus),IDC_EDIT11,g_nParts,0);
		FillColorTable(g_nParts);
	}

	HDC hDC = GetDC(NULL);
	HBITMAP bmStore = GetImageFromMapB(hwStatus,stFiles[0][0],0); 
//	if(!bmStore)
//		bmStore = GetImageFromMap(stFiles[0][0],0); 
	if(!bmStore)
		bmStore = GetImage(stFiles[0][0]);
	BITMAP bm;
	GetObject(bmStore,sizeof(BITMAP),&bm);
	if(bm.bmWidth!=g_nX){
		HBITMAP bmTmp = ShrinkBitmap2(bmStore,g_nX,nY);
		DeleteObject(bmStore);
		bmStore = bmTmp;
		GetObject(bmStore,sizeof(BITMAP),&bm);
	}
	HDC dcStore = CreateCompatibleDC(hDC);
	HBITMAP bmOldStore = (HBITMAP)SelectObject(dcStore,bmStore);
	if(!g_bTest){
		if(g_bRotate)
			pAvi->ChooseCodec(NULL,bm.bmWidth/2,bm.bmHeight/2);
		else
			pAvi->ChooseCodec(NULL,g_3_4?bm.bmHeight*4/3:bm.bmWidth,bm.bmHeight);
	}

	CWaterRoutine wr;
	wr.Create(bm.bmWidth+1,bm.bmHeight);

	HBITMAP bmFrame = CreateCompatibleBitmap(hDC,bm.bmWidth*g_nZoomSize,bm.bmHeight*g_nZoomSize);
	HDC dcFrame = CreateCompatibleDC(hDC);
	HBITMAP bmOldFrame = (HBITMAP)SelectObject(dcFrame,bmFrame);
	SetStretchBltMode(dcFrame,HALFTONE);
	HDC dcPic = CreateCompatibleDC(hDC);
	SetStretchBltMode(dcPic,HALFTONE);
	SetStretchBltMode(dcStore,HALFTONE);

	char szZoomText[40];
	int nParts = 150;
	p = g_stParts.FindStringHash(0,"0");
	if(p!=-1)
		nParts = atoi(g_stParts[p][1]);

	g_nRotateOffs=0;
	p = g_stRotate.FindStringHash(0,"0");
	if(p!=-1)
		g_nRotateOffs = atof(g_stRotate[p][1]);
	g_nColOffsOffs=0;
	p = g_stCycle.FindStringHash(0,"0");
	if(p!=-1)
		g_nColOffsOffs = atof(g_stCycle[p][1]);

	i = GetDlgItemInt(GetParent(hwStatus),IDC_EDIT12,NULL,FALSE);

	for(;!g_bStop && i<stFiles.GetCount();i++){
		strcpy(szZoomText,"ZOOM: ");
		char *szZ = strrchr(stFiles[i][0],'_');
		if(szZ){
			szZ++;
			char *e = strstr(szZ,".jpg");
			if(!e)
				e = strstr(szZ,".kfb");
			int len=strlen(szZ);
			if(e)
				len = (int)e-(int)szZ;
			szZoomText[len+strlen(szZoomText)]=0;
			strncat(szZoomText,strupr(szZ),len);
		}
		RECT r = {0,0,bm.bmWidth*g_nZoomSize,bm.bmHeight*g_nZoomSize};
		char *szFile = strrchr(stFiles[i][0],'\\');
		if(szFile)
			szFile++;
		else
			szFile = stFiles[i][0];
		int nZoomLevel=0;
		char *e = strstr(szFile,"e");
		if(!e)
			e = strstr(szFile,"E");
		if(e){
			e++;
			nZoomLevel = atoi(e);
		}

		for(k=0;k<IMG_COMBINE;k++){
			g_Bmps[k].bUsed=0;
/*			int x;
			for(x=0;x<g_Bmps[k].nWidth;x++)
				delete g_Bmps[k].ppBits[x];
			delete g_Bmps[k].ppBits;
			g_Bmps[k].ppBits=NULL;
			for(x=0;x<g_Bmps[k].nWidth;x++)
				delete g_Bmps[k].ppTrans[x];
			delete g_Bmps[k].ppTrans;
			g_Bmps[k].ppTrans=NULL;
			g_Bmps[k].nWidth=0;
			g_Bmps[k].nHeight=0;
			*g_Bmps[k].szFile=0;
*/		}
		//delete g_Bmps[0].ppBits;
wsprintf(szStatus,"Create image M:%d,P:%d,F:%d %s",nMovieNum,i,nFramesNum,szFile);
SetWindowText(hwStatus,szStatus);
		SelectObject(dcFrame,bmOldFrame);
		DeleteObject(bmFrame);
		if(nNOC_Offs){
			g_nParts+=nNOC_Offs;
			if(g_nParts<4)
				g_nParts=4;
			if(g_nParts>1024)
				g_nParts=1024;
			SetDlgItemInt(GetParent(hwStatus),IDC_EDIT11,g_nParts,0);
			FillColorTable(g_nParts);
		}
		RECT rBounds = {0,0,bm.bmWidth/2,bm.bmHeight/2};
		bmFrame = CombineImage(hwStatus,stFiles,i,g_nColOffs,g_nZoomSize,nZoomLevel,g_nX,nY,rBounds);
		bmOldFrame = (HBITMAP)SelectObject(dcFrame,bmFrame);
/*		for(k=0;k<IMG_COMBINE && k+i<stFiles.GetCount();k++){
wsprintf(szStatus,"Create image %d,",k);
wsprintf(szStatus+strlen(szStatus),"M:%d,P:%d,F:%d %s",nMovieNum,i,nFramesNum,szFile);
SetWindowText(hwStatus,szStatus);
			HBITMAP bmPic = GetImageFromMapB(stFiles[i+k][0],0); 
			if(!bmPic)
				bmPic = GetImageFromMap(stFiles[i+k][0],0); 
			if(!bmPic)
				bmPic = GetImage(stFiles[i+k][0]);
			if(nZoomLevel>300)
				FixDiagonalGlitch(bmPic);
			BITMAP bm2;
			GetObject(bmPic,sizeof(BITMAP),&bm2);
			HBITMAP bmOldPic = (HBITMAP)SelectObject(dcPic,bmPic);
			StretchBlt(dcFrame,r.left,r.top,r.right-r.left,r.bottom-r.top,dcPic,0,0,bm2.bmWidth,bm2.bmHeight,SRCCOPY);
			SelectObject(dcPic,bmOldPic);
			DeleteObject(bmPic);

			int offs = (g_nZoomSize-1)*(r.right-r.left)/(2*g_nZoomSize);
			r.left+=offs;
			r.right-=offs;
			if(r.right-r.left<20)
				break;
			offs = (g_nZoomSize-1)*(r.bottom-r.top)/(2*g_nZoomSize);
			r.top+=offs;
			r.bottom-=offs;
		}
*/
		char szNum[40];
		itoa(i,szNum,10);
		p = g_stParts.FindStringHash(0,szNum);
		if(p!=-1)
			nParts = atoi(g_stParts[p][1]);
		int nNextParts=nParts;

		p = g_stNOC.FindStringHash(0,szNum);
		if(p!=-1)
			nNOC_Offs = atoi(g_stNOC[p][1]);

		itoa(i+1,szNum,10);
		int np = g_stParts.FindStringHash(0,szNum);
		if(np!=-1)
			nNextParts = atoi(g_stParts[np][1]);

		int nPrevParts = nParts;

		double exp = 1;
		double mul = pow(10,log10(g_nZoomSize)/(nParts));
		double mulNext = pow(10,log10(g_nZoomSize)/(nNextParts));
		double mulOffs = (mulNext-mul)/(nParts<nNextParts?nParts:nNextParts);
		if(nParts<nNextParts)
			nParts=nNextParts;
		r.left=r.top=0;
		r.right=bm.bmWidth*g_nZoomSize;
		r.bottom=bm.bmHeight*g_nZoomSize;
		int nMX = r.right/2;
		int nMY = r.bottom/2;
		int f=0;

		np = g_stDivision.FindStringHash(0,szNum);
		double dbColorDivNext = g_nColorDiv;
		double dbColorDivPrev = g_nColorDiv;
		double dbColorDivFrame = 0;
		g_nColorDivOffs=0;
		if(np!=-1){
			dbColorDivNext = atof(g_stDivision[np][1]);
			double diff = dbColorDivNext/g_nColorDiv;
			dbColorDivFrame = pow(10,log10(diff)/nParts);
			g_nColorDivOffs = dbColorDivFrame;
			if(diff<0){
				dbColorDivPrev = dbColorDivNext;
				g_nColorDivOffs=-diff;
				dbColorDivFrame=1/dbColorDivFrame;
			}
		}

		double dbRotateOffs=0, dbNextRotateOffs=g_nRotateOffs;
		np = g_stRotate.FindStringHash(0,szNum);
		BOOL bRotateReset=FALSE;
		if(np!=-1){
			dbNextRotateOffs = atof(g_stRotate[np][1]);
			if(toupper(*g_stRotate[np][1])=='R'){
				bRotateReset=TRUE;
				g_nRotateOffs = dbRotateOffs = dbNextRotateOffs = 0;
			}
			else
				dbRotateOffs = (dbNextRotateOffs - g_nRotateOffs)/nParts;
		}

		double dbColOffs=0, dbNextColOffs=g_nColOffsOffs;
		np = g_stCycle.FindStringHash(0,szNum);
		if(np!=-1){
			dbNextColOffs = atof(g_stCycle[np][1]);
			dbColOffs = (dbNextColOffs - g_nColOffsOffs)/nParts;
		}

		double nLeftPos = g_nX;
		double nLeftPosOffs = nLeftPos/(double)nParts;
		double nLeftPosOffsOffs = ((double)nParts-(double)nNextParts)/(double)nParts;

		for(k=0;!g_bStop && (k<nParts || (!g_bSMD && i==stFiles.GetCount()-1));k++){
			if(i<stFiles.GetCount()-1 && (exp<1/(double)g_nZoomSize || mul<1))
				break;
			g_nRotateOffs+=dbRotateOffs;
			if((dbNextRotateOffs>0 && g_nRotateOffs>dbNextRotateOffs) || (dbNextRotateOffs<0 && g_nRotateOffs<dbNextRotateOffs))
				g_nRotateOffs=dbNextRotateOffs;
			if(bRotateReset){
				if(g_nRotate>0)
					g_nRotate += (360 - g_nRotate)/3;
				else
					g_nRotate += (-360 - g_nRotate)/3;
			}

			g_nColOffsOffs+=dbColOffs;
			if((dbNextColOffs>0 && g_nColOffsOffs>dbNextColOffs) || (dbNextColOffs<0 && g_nColOffsOffs<dbNextColOffs))
				g_nColOffsOffs=dbNextColOffs;

			f++;
			int nXOffs = (int)(exp*r.right/2+.5);
			int nYOffs = (int)(exp*r.bottom/2+.5);
			exp/=mul;
			if((mulNext>mul && mul+mulOffs>mulNext) || (mulNext<=mul && mul+mulOffs<mulNext))
				mul=mulNext;
			else
				mul+=mulOffs;
			if(nXOffs<3)
				break;
			if(i<stFiles.GetCount()-1 && bm.bmWidth > 2*nXOffs)
				break;

			if(g_nColOffsOffs || g_nColorDivOffs || nNOC_Offs || g_nColorMethod==4){// && nFramesNum%2==0){
				BITMAP bmOld;
				GetObject(bmFrame,sizeof(BITMAP),&bmOld);
				SelectObject(dcFrame,bmOldFrame);
				DeleteObject(bmFrame);
				g_nColOffs+=g_nColOffsOffs;
				if(g_nColorDivOffs)
					g_nColorDiv=dbColorDivPrev*g_nColorDivOffs;
/*				if(g_nColOffs>1024*g_nColorDiv && !g_bWaves)
					g_nColOffs-=1024*g_nColorDiv;
				else if(g_nColOffs<-1024*g_nColorDiv && !g_bWaves)
					g_nColOffs+=1024*g_nColorDiv;
*/				if(nNOC_Offs){
					g_nParts+=nNOC_Offs;
					if(g_nParts<4)
						g_nParts=4;
					if(g_nParts>1024)
						g_nParts=1024;
					SetDlgItemInt(GetParent(hwStatus),IDC_EDIT11,g_nParts,0);
					FillColorTable(g_nParts);
				}
				RECT rBounds = {(nMX-nXOffs)/2,(nMY-nYOffs)/2,nXOffs,nYOffs};
				bmFrame = CombineImage(hwStatus,stFiles,i,g_nColOffs,g_nZoomSize,nZoomLevel,g_nX, nY,rBounds);
				BITMAP bmNew;
				GetObject(bmFrame,sizeof(BITMAP),&bmNew);
				if(bmOld.bmWidth!=bmNew.bmWidth){
					HBITMAP bmNewFrame = ShrinkBitmap2(bmFrame,bmOld.bmWidth,bmOld.bmHeight);
					DeleteObject(bmFrame);
					bmFrame = bmNewFrame;
				}
				bmOldFrame = (HBITMAP)SelectObject(dcFrame,bmFrame);
			}

			if(g_bLeftScroll){
				if(nLeftPos<0)
					break;
				BitBlt(dcStore,0,0,bm.bmWidth,bm.bmHeight,dcFrame,nLeftPos,0,SRCCOPY);
				nLeftPosOffs+=nLeftPosOffsOffs;
				if(nLeftPosOffsOffs>0 && nLeftPosOffs>g_nX/nNextParts)
					nLeftPosOffs=g_nX/nNextParts;
				if(nLeftPosOffsOffs<0 && nLeftPosOffs<g_nX/nNextParts)
					nLeftPosOffs=g_nX/nNextParts;
				nLeftPos-=nLeftPosOffs;
			}
			else
				StretchBlt(dcStore,0,0,bm.bmWidth,bm.bmHeight,dcFrame,nMX-nXOffs,nMY-nYOffs,2*nXOffs,2*nYOffs,SRCCOPY);

			SelectObject(dcStore,bmOldStore);
			if(g_bZoomText)
				SetZoomText(bmStore,szZoomText);
			pAvi = AppendFrame(pAvi,bmStore,nFramesNum,g_nMaxFrames,nMovieNum,szMovie,wr,szZoomText,0);//i==stFiles.GetCount()-1);
			wsprintf(szStatus,"M:%d,P:%d,F:%d %s",nMovieNum,i,nFramesNum,szFile);
			SetWindowText(hwStatus,szStatus);

			bmOldStore = (HBITMAP)SelectObject(dcStore,bmStore);
			sprintf(szStatus,"M:%d,P:%d,F:%d,C:%f %s",nMovieNum,i,nFramesNum,g_nColOffs,strrchr(stFiles[i][0],'\\')+1);
			SetWindowText(hwStatus,szStatus);
			
			if(i==stFiles.GetCount()-1){
				if(g_bSMD)
					break;
				k=0;
//				if(f>=100 && f%50==0)
//					wr.SineBlob(bm.bmWidth/4+rand()%(bm.bmWidth/2),bm.bmHeight/4+rand()%(bm.bmHeight/2),12,40000,wr.m_iHpage);
				if(f>600)
					break;
			}
			g_nColorDivOffs*=dbColorDivFrame;
		}
		if(bRotateReset)
			g_nRotate=0;
		nParts = nPrevParts;
		g_nRotateOffs=dbNextRotateOffs;
		if(bRotateReset)
			g_nRotate=g_nRotateOffs=0;
		g_nColOffsOffs=dbNextColOffs;
		g_nColorDiv = dbColorDivNext;
	}
	delete pAvi;
	wsprintf(szStatus,"Done! M:%d,P:%d,F:%d, C:%f",nMovieNum,i,nFramesNum,g_nColOffs);
	SetWindowText(hwStatus,szStatus);
	SendMessage(GetParent(hwStatus),WM_USER+11,0,0);
	return 1;
}

int WINAPI MainProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	if(uMsg==WM_COMMAND){
		if(wParam==IDOK){
			if(!g_bRunning){
				g_bRunning=TRUE;
				SetDlgItemText(hWnd,IDOK,"Stop");
				DWORD dw;
				CloseHandle(CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ThRun,(LPVOID)GetDlgItem(hWnd,IDC_EDIT1),0,&dw));
			}
			else
				g_bStop=TRUE;
		}
		else if(wParam==IDCANCEL)
			EndDialog(hWnd,0);
	}
	return 0;
}
int (*SizeOfLD)();
void *(*AllocateArray)(int nSize);
void (*ReleaseArray)(void *p);
void (*AssignInt)(void *p,int *pnValue);
void (*AssignDouble)(void *p,double *pnDouble);
void (*AssignLD)(void *p,void *ld);
void (*ToInt)(void *p,int *pnValue);
void (*ToDouble)(void *p,double *pnDouble);
void (*Multiply)(void *a,void *b,void *ret);
void (*Divide)(void *a,void *b,void *ret);
void (*Add)(void *a,void *b,void *ret);
void (*Subtract)(void *a,void *b,void *ret);
int (*GT)(void *a,void *b);
int (*LT)(void *a,void *b);
int (*Equal)(void *a,void *b);
void (*Print)(void *a,char *szRet);
void (*ConvertFromFixedFloat)(void *p,int nValues, __int64 *pValues, BOOL bSign);
void InitLD()
{
	HINSTANCE hLD = LoadLibrary("C:\\pojects\\long_double\\Project1.dll");
	SizeOfLD = (int(*)())GetProcAddress(hLD,"SizeOfLD");
	AllocateArray = (void*(*)(int))GetProcAddress(hLD,"AllocateArray");
	ReleaseArray = (void(*)(void*))GetProcAddress(hLD,"ReleaseArray");
	AssignInt = (void(*)(void*,int*))GetProcAddress(hLD,"AssignInt");
	AssignDouble = (void(*)(void*,double*))GetProcAddress(hLD,"AssignDouble");
	AssignLD = (void(*)(void*,void*))GetProcAddress(hLD,"AssignLD");
	ToInt = (void(*)(void*,int*))GetProcAddress(hLD,"ToInt");
	ToDouble = (void(*)(void*,double*))GetProcAddress(hLD,"ToDouble");
	Multiply = (void(*)(void*,void*,void*))GetProcAddress(hLD,"Multiply");
	Divide = (void(*)(void*,void*,void*))GetProcAddress(hLD,"Divide");
	Add = (void(*)(void*,void*,void*))GetProcAddress(hLD,"Add");
	Subtract = (void(*)(void*,void*,void*))GetProcAddress(hLD,"Subtract");
	GT = (int(*)(void*,void*))GetProcAddress(hLD,"GT");
	LT = (int(*)(void*,void*))GetProcAddress(hLD,"LT");
	Equal = (int(*)(void*,void*))GetProcAddress(hLD,"Equal");
	Print = (void(*)(void*,char*))GetProcAddress(hLD,"Print");
	ConvertFromFixedFloat = (void(*)(void*,int,__int64*,BOOL))GetProcAddress(hLD,"ConvertFromFixedFloat");
}
int WINAPI PreviewProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	if(uMsg==WM_INITDIALOG)
		SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)LoadIcon(GetModuleHandle(NULL),MAKEINTRESOURCE(IDI_ICON1)));
	return 0;
}
int g_nFiles=1;
CListBoxEdit *g_pListBoxSpeed=NULL;
CListBoxEdit *g_pListBoxRotation=NULL;
CListBoxEdit *g_pListBoxCycle=NULL;
CListBoxEdit *g_pListBoxDivision=NULL;
CListBoxEdit *g_pListBoxNOC=NULL;
CListBoxEdit *g_pListBoxWaves=NULL;
CListBoxEdit *g_pListBoxLongWaves=NULL;
int WINAPI NumProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	if(uMsg==WM_COMMAND){
		if(wParam==IDCANCEL)
			EndDialog(hWnd,-1);
		else if(wParam==IDOK){
			char szNum[256];
			GetDlgItemText(hWnd,IDC_EDIT1,szNum,sizeof(szNum));
			EndDialog(hWnd,atoi(szNum));
		}
	}
	return 0;
}

void GetMovieLength(HWND hWnd, int nKeyFrames, int nFPS)
{
	if(!nKeyFrames)
		return;
	CStringVektor sv;
	if(g_pListBoxSpeed)
		g_pListBoxSpeed->GetStrings(&sv);
	char *sz = sv.ToText("\n");
	g_stParts.Reset();
	g_stParts.SplitString(sz,"\t","\n");
	sv.DeleteToText(sz);
	g_stParts.M3QSort(0,0,1);
	int nParts = atoi(g_stParts[0][1]);
	if(nParts==0)
		nParts=150;
	int i;
	int nNextSpec = 1;
	int nFrames=nParts;
	for(i=1;i<nKeyFrames;i++){
		if(atoi(g_stParts[nNextSpec][0])==i){
			nParts = atoi(g_stParts[nNextSpec][1]);
			nNextSpec++;
		}
		nFrames+=nParts;
	}
	char szTime[256];
	nFrames/=(nFPS?nFPS:1);
	wsprintf(szTime,"%02d:%02d:%02d",nFrames/36000,(nFrames/60)%60,nFrames%60);
	SetDlgItemText(hWnd,IDC_EDIT4,szTime);
}
int WINAPI KeyFramesProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	if(uMsg==WM_INITDIALOG){
		SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)LoadIcon(GetModuleHandle(NULL),MAKEINTRESOURCE(IDI_ICON1)));
		SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM)"Hue");
		SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM)"Saturation");
		SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM)"Brightness");
		SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM)"Wave(RGB)");
		int dwText=25;
		SetDlgItemText(hWnd,IDC_EDIT12,"0");
		SendDlgItemMessage(hWnd,IDC_LIST1, LB_SETTABSTOPS, (WPARAM)1, (LPARAM)(LPINT)&dwText);
		SendDlgItemMessage(hWnd,IDC_LIST2, LB_SETTABSTOPS, (WPARAM)1, (LPARAM)(LPINT)&dwText);
		SendDlgItemMessage(hWnd,IDC_LIST3, LB_SETTABSTOPS, (WPARAM)1, (LPARAM)(LPINT)&dwText);
		SendDlgItemMessage(hWnd,IDC_LIST4, LB_SETTABSTOPS, (WPARAM)1, (LPARAM)(LPINT)&dwText);
		SendDlgItemMessage(hWnd,IDC_LIST5, LB_SETTABSTOPS, (WPARAM)1, (LPARAM)(LPINT)&dwText);

		SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"Standard");
		SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"Square root");
		SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"Cubic root");
		SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"Logarithm");
		SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"Histogram");
		SendDlgItemMessage(hWnd,IDC_COMBO3,CB_SETCURSEL,0,0);


		SendDlgItemMessage(hWnd,IDC_COMBO2,CB_ADDSTRING,0,(LPARAM)"24");
		SendDlgItemMessage(hWnd,IDC_COMBO2,CB_ADDSTRING,0,(LPARAM)"32");
		SendDlgItemMessage(hWnd,IDC_COMBO2,CB_SETCURSEL,0,0);
		g_hwPreview = CreateDialog(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_DIALOG3),hWnd,PreviewProc);
		RECT r, pr;
		GetWindowRect(hWnd,&r);
		GetWindowRect(g_hwPreview,&pr);
		pr.right-=pr.left;
		pr.bottom-=pr.top;
		MoveWindow(g_hwPreview,r.right,r.top,pr.right,pr.bottom,TRUE);
		ShowWindow(g_hwPreview,SW_SHOWNA);
		SetDlgItemInt(hWnd,IDC_EDIT10,g_nFPS,FALSE);
		SendDlgItemMessage(hWnd,IDC_LIST1,LB_ADDSTRING,0,(LPARAM)"0\t25");
		SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"2");
		SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"4");
		SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"8");
		SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"16");
		SendDlgItemMessage(hWnd,IDC_COMBO1,CB_SETCURSEL,0,0);

		SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"2");
		SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"3");
		SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4");
		SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5");
		SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"6");
		SendDlgItemMessage(hWnd,IDC_COMBO5,CB_SETCURSEL,2,0);

		HWND hwExtra = GetDlgItem(hWnd,IDC_EDIT3);
		g_pListBoxSpeed = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON2), GetDlgItem(hWnd,IDC_BUTTON3), GetDlgItem(hWnd,IDC_BUTTON4), GetDlgItem(hWnd,IDC_EDIT2), GetDlgItem(hWnd,IDC_LIST1),&hwExtra, 1);
		hwExtra = GetDlgItem(hWnd,IDC_EDIT15);
		g_pListBoxRotation = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON8), GetDlgItem(hWnd,IDC_BUTTON9), GetDlgItem(hWnd,IDC_BUTTON10), GetDlgItem(hWnd,IDC_EDIT14), GetDlgItem(hWnd,IDC_LIST2),&hwExtra, 1);
		hwExtra = GetDlgItem(hWnd,IDC_EDIT17);
		g_pListBoxCycle = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON12), GetDlgItem(hWnd,IDC_BUTTON13), GetDlgItem(hWnd,IDC_BUTTON14), GetDlgItem(hWnd,IDC_EDIT16), GetDlgItem(hWnd,IDC_LIST3),&hwExtra, 1);
		hwExtra = GetDlgItem(hWnd,IDC_EDIT19);
		g_pListBoxDivision = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON16), GetDlgItem(hWnd,IDC_BUTTON17), GetDlgItem(hWnd,IDC_BUTTON18), GetDlgItem(hWnd,IDC_EDIT18), GetDlgItem(hWnd,IDC_LIST4),&hwExtra, 1);
		hwExtra = GetDlgItem(hWnd,IDC_EDIT21);
		g_pListBoxNOC = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON22), GetDlgItem(hWnd,IDC_BUTTON23), GetDlgItem(hWnd,IDC_BUTTON24), GetDlgItem(hWnd,IDC_EDIT20), GetDlgItem(hWnd,IDC_LIST5),&hwExtra, 1);
		hwExtra = GetDlgItem(hWnd,IDC_EDIT23);
		g_pListBoxWaves = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON26), GetDlgItem(hWnd,IDC_BUTTON27), GetDlgItem(hWnd,IDC_BUTTON28), GetDlgItem(hWnd,IDC_EDIT24), GetDlgItem(hWnd,IDC_LIST6),&hwExtra, 1);
		HWND hwExtras[2];
		hwExtras[0] = GetDlgItem(hWnd,IDC_EDIT27);
		hwExtras[1] = GetDlgItem(hWnd,IDC_EDIT28);
		g_pListBoxLongWaves = new CListBoxEdit(GetDlgItem(hWnd,IDC_BUTTON36), GetDlgItem(hWnd,IDC_BUTTON37), GetDlgItem(hWnd,IDC_BUTTON38), GetDlgItem(hWnd,IDC_EDIT26), GetDlgItem(hWnd,IDC_LIST8),hwExtras, 2);
		SendDlgItemMessage(hWnd,IDC_CHECK2,BM_SETCHECK,1,0);
		SendDlgItemMessage(hWnd,IDC_CHECK3,BM_SETCHECK,1,0);
		SetDlgItemText(hWnd,IDC_EDIT13,g_szFontName);
	}
	else if(uMsg==WM_COMMAND){
		if(wParam==IDCANCEL)
			EndDialog(hWnd,0);
		else if(HIWORD(wParam)==LBN_SELCHANGE && LOWORD(wParam)==IDC_LIST6){
			char szTmp[256];
			int i = SendDlgItemMessage(hWnd,IDC_LIST6,LB_GETCURSEL,0,0);
			if(i!=-1){
				SendDlgItemMessage(hWnd,IDC_LIST6,LB_GETTEXT,i,(LPARAM)szTmp);
				if(*szTmp=='H')
					SendDlgItemMessage(hWnd,IDC_COMBO4,CB_SETCURSEL,0,0);
				else if(*szTmp=='S')
					SendDlgItemMessage(hWnd,IDC_COMBO4,CB_SETCURSEL,1,0);
				else if(*szTmp=='B')
					SendDlgItemMessage(hWnd,IDC_COMBO4,CB_SETCURSEL,2,0);
				else if(*szTmp=='W')
					SendDlgItemMessage(hWnd,IDC_COMBO4,CB_SETCURSEL,3,0);
			}
		}
		else if(HIWORD(wParam)==CBN_SELCHANGE && LOWORD(wParam)==IDC_COMBO4){
			int i = SendDlgItemMessage(hWnd,IDC_COMBO4,CB_GETCURSEL,0,0);
			if(i==0)
				SetDlgItemText(hWnd,IDC_EDIT24,"H");
			else if(i==1)
				SetDlgItemText(hWnd,IDC_EDIT24,"S");
			else if(i==2)
				SetDlgItemText(hWnd,IDC_EDIT24,"B");
			else if(i==3)
				SetDlgItemText(hWnd,IDC_EDIT24,"W");
		}
		else if(wParam==IDC_BUTTON30){
			char szTmp[25];
			srand(GetTickCount());
			int val = rand()%2000;
			BOOL bPrime=0, j;
			while(!bPrime && val>0){
				bPrime=1;
				for(j=2;bPrime && j<val/2;j++)
					if(val%j==0)
						bPrime=0;
				if(!bPrime)
					val--;
			}
			wsprintf(szTmp,"H\t%d",val);
			SendDlgItemMessage(hWnd,IDC_LIST6,LB_ADDSTRING,0,(LPARAM)szTmp);
			val = rand()%2000;
			bPrime=0;
			while(!bPrime && val>0){
				bPrime=1;
				for(j=2;bPrime && j<val/2;j++)
					if(val%j==0)
						bPrime=0;
				if(!bPrime)
					val--;
			}
			wsprintf(szTmp,"S\t%d",val);
			SendDlgItemMessage(hWnd,IDC_LIST6,LB_ADDSTRING,0,(LPARAM)szTmp);
			val = rand()%2000;
			bPrime=0;
			while(!bPrime && val>0){
				bPrime=1;
				for(j=2;bPrime && j<val/2;j++)
					if(val%j==0)
						bPrime=0;
				if(!bPrime)
					val--;
			}
			wsprintf(szTmp,"B\t%d",val);
			SendDlgItemMessage(hWnd,IDC_LIST6,LB_ADDSTRING,0,(LPARAM)szTmp);
		}
		else if(wParam==IDC_BUTTON33){
			SetDlgItemText(hWnd,IDC_BUTTON33,"...");
			int i;
			for(i=0;i<IMG_COMBINE;i++)
				g_Bmps[i].bUsed=FALSE;
			char szFolder[256];
			GetDlgItemText(hWnd,IDC_EDIT1,szFolder,sizeof(szFolder));
			if(szFolder[strlen(szFolder)-1]!='\\')
				strcat(szFolder,"\\");
			strcat(szFolder,"*.kfb");
			WIN32_FIND_DATA fd;
			HANDLE hFind = FindFirstFile(szFolder,&fd);
			CStringTable st;
			do{
				strcpy(strrchr(szFolder,'\\')+1,fd.cFileName);
				st.AddRow();
				st.AddString(st.GetCount()-1,szFolder);
			}while(FindNextFile(hFind,&fd));
			FindClose(hFind);
			st.M3QSort(0,1);

			g_nImg_Combine = SendDlgItemMessage(hWnd,IDC_COMBO5,CB_GETCURSEL,0,0);
			g_bWaves = SendDlgItemMessage(hWnd,IDC_CHECK6,BM_GETCHECK,0,0);
			CStringVektor sv;
			g_pListBoxWaves->GetStrings(&sv);
			char *sz = sv.ToText("\n");
			CStringTable stWaves(sz,"\t","\n");
			sv.DeleteToText(sz);
			for(i=0;i<stWaves.GetCount() && i<WAVE_COLORS_NUM;i++){
				if(*stWaves[i][0]=='H')
					g_WaveColors[i].nType=0;
				else if(*stWaves[i][0]=='S')
					g_WaveColors[i].nType=1;
				else if(*stWaves[i][0]=='B')
					g_WaveColors[i].nType=2;
				else if(*stWaves[i][0]=='W')
					g_WaveColors[i].nType=3;
				g_WaveColors[i].nPeriod = atoi(stWaves[i][1]);
				g_WaveColors[i].nStart = atoi(stWaves[i][2]);
				g_WaveColors[i].bLast=0;
			}
			g_WaveColors[i].bLast=1;

			int nFrame = GetDlgItemInt(hWnd,IDC_EDIT12,NULL,FALSE);
			HBITMAP bm = GetImageFromMapB(NULL,st[nFrame][0],0);
			ShowPreview(bm);
			DeleteObject(bm);
			SetDlgItemText(hWnd,IDC_BUTTON33,"Test");
		}
		else if(wParam==IDC_BUTTON20){
			char szFile[256]={0};
			if(!BrowseFile(hWnd,FALSE,"Save settings","Key movile maker file\0*.kmm\0",szFile,sizeof(szFile)))
				return 0;
			DWORD dw;
			HANDLE hFile = CreateFile(szFile,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL);
			if(hFile==INVALID_HANDLE_VALUE)
				return MessageBox(hWnd,"Could not create file","Error",MB_OK|MB_ICONSTOP);
			char *szTmp;
			szTmp="SPEED: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			CStringVektor sv;
			g_pListBoxSpeed->GetStrings(&sv);
			szTmp = sv.ToText(",");
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.DeleteToText(szTmp);
			sv.Clean();
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="ROTATE: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.Clean();
			g_pListBoxRotation->GetStrings(&sv);
			szTmp = sv.ToText(",");
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.DeleteToText(szTmp);
			sv.Clean();
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="CYCLE: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.Clean();
			g_pListBoxCycle->GetStrings(&sv);
			szTmp = sv.ToText(",");
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.DeleteToText(szTmp);
			sv.Clean();
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="DIVIDE: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.Clean();
			g_pListBoxDivision->GetStrings(&sv);
			szTmp = sv.ToText(",");
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.DeleteToText(szTmp);
			sv.Clean();
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="NOC: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.Clean();
			g_pListBoxNOC->GetStrings(&sv);
			szTmp = sv.ToText(",");
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.DeleteToText(szTmp);
			sv.Clean();
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			if(SendDlgItemMessage(hWnd,IDC_CHECK6,BM_GETCHECK,0,0)){
				szTmp="WAVES: ";
				WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
				sv.Clean();
				g_pListBoxWaves->GetStrings(&sv);
				szTmp = sv.ToText(",");
				WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
				sv.DeleteToText(szTmp);
				sv.Clean();
				WriteFile(hFile,"\r\n",2,&dw,NULL);
			}

			szTmp="LONGWAVES: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.Clean();
			g_pListBoxLongWaves->GetStrings(&sv);
			szTmp = sv.ToText(":");
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			sv.DeleteToText(szTmp);
			sv.Clean();
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="DIR: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			GetDlgItemText(hWnd,IDC_EDIT1,szFile,sizeof(szFile));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="FPS: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			GetDlgItemText(hWnd,IDC_EDIT10,szFile,sizeof(szFile));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="FPM: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			GetDlgItemText(hWnd,IDC_EDIT9,szFile,sizeof(szFile));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="ZOL: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			wsprintf(szFile,"%d",SendDlgItemMessage(hWnd,IDC_COMBO1,CB_GETCURSEL,0,0));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="SZT: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			wsprintf(szFile,"%d",SendDlgItemMessage(hWnd,IDC_CHECK2,BM_GETCHECK,0,0));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="SCT: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			wsprintf(szFile,"%d",SendDlgItemMessage(hWnd,IDC_CHECK3,BM_GETCHECK,0,0));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="SMD: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			wsprintf(szFile,"%d",SendDlgItemMessage(hWnd,IDC_CHECK4,BM_GETCHECK,0,0));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="MSZ: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			GetDlgItemText(hWnd,IDC_EDIT7,szFile,sizeof(szFile));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="BIT: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			if(SendDlgItemMessage(hWnd,IDC_COMBO2,CB_GETCURSEL,0,0))
				szTmp="32";
			else
				szTmp="24";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="COL: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			wsprintf(szFile,"%d",SendDlgItemMessage(hWnd,IDC_COMBO3,CB_GETCURSEL,0,0));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			szTmp="FONT: ";
			WriteFile(hFile,szTmp,strlen(szTmp),&dw,NULL);
			GetDlgItemText(hWnd,IDC_EDIT13,szFile,sizeof(szFile));
			WriteFile(hFile,szFile,strlen(szFile),&dw,NULL);
			WriteFile(hFile,"\r\n",2,&dw,NULL);

			CloseHandle(hFile);
		}
		else if(wParam==IDC_BUTTON39){
			static COLORREF colCust[16]={0};
			CHOOSECOLOR col={sizeof(CHOOSECOLOR)};
			col.hwndOwner = hWnd;
			col.lpCustColors = colCust;
			col.Flags = CC_RGBINIT;
			char szCol[256];
			GetDlgItemText(hWnd,IDC_EDIT26,szCol,sizeof(szCol));
			CStringTable st(szCol,"",",");
			col.rgbResult = RGB(atoi(st[0][0]),atoi(st[1][0]),atoi(st[2][0]));
			if(ChooseColor(&col)){
				char *cc = (char*)&col.rgbResult;
				wsprintf(szCol,"%d,%d,%d",(unsigned char)cc[0],(unsigned char)cc[1],(unsigned char)cc[2]);
				SetDlgItemText(hWnd,IDC_EDIT26,szCol);
			}
		}
		else if(wParam==IDC_BUTTON21){
			char szFile[256]={0};
			if(!BrowseFile(hWnd,TRUE,"Load settings","Key movile maker file\0*.kmm\0",szFile,sizeof(szFile)))
				return 0;
			DWORD dw;
			HANDLE hFile = CreateFile(szFile,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
			if(hFile==INVALID_HANDLE_VALUE)
				return MessageBox(hWnd,"Could not create file","Error",MB_OK|MB_ICONSTOP);
			int nLen = GetFileSize(hFile,NULL);
			char *szData = new char[nLen+1];
			ReadFile(hFile,szData,nLen,&dw,NULL);
			CloseHandle(hFile);
			CStringTable stSettings(szData,": ","\r\n");
			delete szData;
			stSettings.BuildHash(0);
			int i, j;
			CStringTable st;
			if((i = stSettings.FindStringHash(0,"SPEED"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],",","");
				SendDlgItemMessage(hWnd,IDC_LIST1,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST1,LB_ADDSTRING,0,(LPARAM)st[0][j]);
			}
			if((i = stSettings.FindStringHash(0,"ROTATE"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],",","");
				SendDlgItemMessage(hWnd,IDC_LIST2,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST2,LB_ADDSTRING,0,(LPARAM)st[0][j]);
			}
			if((i = stSettings.FindStringHash(0,"CYCLE"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],",","");
				SendDlgItemMessage(hWnd,IDC_LIST3,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST3,LB_ADDSTRING,0,(LPARAM)st[0][j]);
			}
			if((i = stSettings.FindStringHash(0,"DIVIDE"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],",","");
				SendDlgItemMessage(hWnd,IDC_LIST4,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST4,LB_ADDSTRING,0,(LPARAM)st[0][j]);
			}
			if((i = stSettings.FindStringHash(0,"WAVES"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],",","");
				SendDlgItemMessage(hWnd,IDC_LIST6,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST6,LB_ADDSTRING,0,(LPARAM)st[0][j]);
				SendDlgItemMessage(hWnd,IDC_CHECK6,BM_SETCHECK,1,0);
			}
			if((i = stSettings.FindStringHash(0,"LONGWAVES"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],":","");
				SendDlgItemMessage(hWnd,IDC_LIST8,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST8,LB_ADDSTRING,0,(LPARAM)st[0][j]);
			}
/*			if((i = stSettings.FindStringHash(0,"WAVE-INTERVALS"))!=-1){
				st.Reset();
				st.SplitString(stSettings[i][1],",","");
				SendDlgItemMessage(hWnd,IDC_LIST7,LB_RESETCONTENT,0,0);
				for(j=0;j<st[0].GetCount();j++)
					SendDlgItemMessage(hWnd,IDC_LIST7,LB_ADDSTRING,0,(LPARAM)st[0][j]);
			}
*/			if((i = stSettings.FindStringHash(0,"DIR"))!=-1)
				SetDlgItemText(hWnd,IDC_EDIT1,stSettings[i][1]);
			if((i = stSettings.FindStringHash(0,"FPS"))!=-1)
				SetDlgItemText(hWnd,IDC_EDIT9,stSettings[i][1]);
			if((i = stSettings.FindStringHash(0,"ZOL"))!=-1)
				SendDlgItemMessage(hWnd,IDC_COMBO1,CB_SETCURSEL,atoi(stSettings[i][1]),0);
			if((i = stSettings.FindStringHash(0,"COL"))!=-1)
				SendDlgItemMessage(hWnd,IDC_COMBO3,CB_SETCURSEL,atoi(stSettings[i][1]),0);
			if((i = stSettings.FindStringHash(0,"SZT"))!=-1)
				SendDlgItemMessage(hWnd,IDC_CHECK2,BM_SETCHECK,atoi(stSettings[i][1]),0);
			if((i = stSettings.FindStringHash(0,"FONT"))!=-1)
				SetDlgItemText(hWnd,IDC_EDIT13,stSettings[i][1]);
			if((i = stSettings.FindStringHash(0,"SCM"))!=-1)
				SendDlgItemMessage(hWnd,IDC_CHECK3,BM_SETCHECK,atoi(stSettings[i][1]),0);
			if((i = stSettings.FindStringHash(0,"SMD"))!=-1)
				SendDlgItemMessage(hWnd,IDC_CHECK4,BM_SETCHECK,atoi(stSettings[i][1]),0);
			if((i = stSettings.FindStringHash(0,"MSZ"))!=-1)
				SetDlgItemText(hWnd,IDC_EDIT7,stSettings[i][1]);
			if((i = stSettings.FindStringHash(0,"BIT"))!=-1){
				if(atoi(stSettings[i][1])==32)
					SendDlgItemMessage(hWnd,IDC_COMBO2,CB_SETCURSEL,1,0);
				else
					SendDlgItemMessage(hWnd,IDC_COMBO2,CB_SETCURSEL,0,0);
			}
		}
		else if(wParam==IDC_BUTTON1){
			char szFolder[256];
			GetDlgItemText(hWnd,IDC_EDIT1,szFolder,sizeof(szFolder));
			if(Browse(hWnd,szFolder,sizeof(szFolder))){
				SetDlgItemText(hWnd,IDC_EDIT1,szFolder);
				if(szFolder[strlen(szFolder)-1]!='\\')
					strcat(szFolder,"\\");
				strcat(szFolder,"*.kfb");
				WIN32_FIND_DATA fd;
				HANDLE hFind = FindFirstFile(szFolder,&fd);
				strcpy(strrchr(szFolder,'\\')+1,fd.cFileName);
				DWORD dw;
				HANDLE hFile = CreateFile(szFolder,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
				if(hFile==INVALID_HANDLE_VALUE)
					return MessageBox(hWnd,"Could not open file in this directory","Error",MB_ICONSTOP|MB_OK);
				int nX, nY;
				char szId[4];
				ReadFile(hFile,szId,3,&dw,NULL);
				szId[3]=0;
				ReadFile(hFile,&nX,sizeof(int),&dw,NULL);
				ReadFile(hFile,&nY,sizeof(int),&dw,NULL);
				CloseHandle(hFile);
				if(strcmp(szId,"KFB") && strcmp(szId,"KFC"))
					return MessageBox(hWnd,"File is either corrupt or of another type","Error",MB_ICONSTOP|MB_OK);
				SetDlgItemInt(hWnd,IDC_EDIT5,nX,FALSE);
				SetDlgItemInt(hWnd,IDC_EDIT7,nX,FALSE);
				SetDlgItemInt(hWnd,IDC_EDIT6,nY,FALSE);
				SetDlgItemInt(hWnd,IDC_EDIT8,nY,FALSE);
				int nFramesPerMovie = 1037000000/(nX*nY);
				SetDlgItemInt(hWnd,IDC_EDIT9,nFramesPerMovie,FALSE);
				g_nFiles=0;
				do{
					g_nFiles++;
				}while(FindNextFile(hFind,&fd));
				FindClose(hFind);
				strcpy(szFolder,"*.jpg");
				hFind = FindFirstFile(szFolder,&fd);
				int nJpg=0;
				do{
					nJpg++;
				}while(FindNextFile(hFind,&fd));
				FindClose(hFind);
				if(nJpg>g_nFiles)
					g_nFiles=nJpg;
				GetMovieLength(hWnd,g_nFiles,GetDlgItemInt(hWnd,IDC_EDIT10,NULL,FALSE));
			}
		}
		else if(wParam==IDC_BUTTON29){
			int j, val = GetDlgItemInt(hWnd,IDC_EDIT23,NULL,FALSE);
			BOOL bPrime=0;
			while(!bPrime && val>0){
				bPrime=1;
				for(j=2;bPrime && j<val/2;j++)
					if(val%j==0)
						bPrime=0;
				if(!bPrime)
					val--;
			}
			SetDlgItemInt(hWnd,IDC_EDIT23,val,FALSE);
		}
		else if(wParam==IDOK){
			if(!g_bRunning){
				g_bWaves = SendDlgItemMessage(hWnd,IDC_CHECK6,BM_GETCHECK,0,0);

				if(SendDlgItemMessage(hWnd,IDC_COMBO2,CB_GETCURSEL,0,0))
					g_nBits=32;
				else
					g_nBits=24;

				g_nColorDiv=1;
				int nZ = SendDlgItemMessage(hWnd,IDC_COMBO1,CB_GETCURSEL,0,0);
				if(nZ==0)
					g_nZoomSize=2;
				else if(nZ==1)
					g_nZoomSize=4;
				else if(nZ==2)
					g_nZoomSize=8;
				else if(nZ==3)
					g_nZoomSize=16;
				g_nColorMethod = SendDlgItemMessage(hWnd,IDC_COMBO3,CB_GETCURSEL,0,0);
				char szRotate[25];
//				GetDlgItemText(hWnd,IDC_EDIT11,szRotate,sizeof(szRotate));
//				g_nRotateOffs = atof(szRotate);
				g_nRotate=0;

//				GetDlgItemText(hWnd,IDC_EDIT12,szRotate,sizeof(szRotate));
//				g_nColOffsOffs = atof(szRotate);
				g_nColOffs=0;

				g_nX=GetDlgItemInt(hWnd,IDC_EDIT7,NULL,FALSE);
				g_bTest=SendDlgItemMessage(hWnd,IDC_CHECK1,BM_GETCHECK,0,0);
				GetDlgItemText(hWnd,IDC_EDIT1,g_szFind,sizeof(g_szFind));
				if(g_szFind[strlen(g_szFind)-1]!='\\')
					strcat(g_szFind,"\\");
				strcat(g_szFind,"*.kfb");
				g_bZoomText = SendDlgItemMessage(hWnd,IDC_CHECK2,BM_GETCHECK,0,0);
				g_bTrans = SendDlgItemMessage(hWnd,IDC_CHECK3,BM_GETCHECK,0,0);
				g_bFixed = SendDlgItemMessage(hWnd,IDC_CHECK8,BM_GETCHECK,0,0);
				g_bSMD = SendDlgItemMessage(hWnd,IDC_CHECK4,BM_GETCHECK,0,0);
				g_bLeftScroll = SendDlgItemMessage(hWnd,IDC_CHECK7,BM_GETCHECK,0,0);
				g_3_4 = SendDlgItemMessage(hWnd,IDC_CHECK5,BM_GETCHECK,0,0);
				GetDlgItemText(hWnd,IDC_EDIT13,g_szFontName,sizeof(g_szFontName));
				CStringVektor sv;
				if(g_pListBoxSpeed)
					g_pListBoxSpeed->GetStrings(&sv);
				char *sz = sv.ToText("\n");
				g_stParts.Reset();
				g_stParts.SplitString(sz,"\t","\n");
				sv.DeleteToText(sz);
				g_stParts.BuildHash(0);
				
				sv.Clean();
				if(g_pListBoxRotation)
					g_pListBoxRotation->GetStrings(&sv);
				sz = sv.ToText("\n");
				g_stRotate.Reset();
				g_stRotate.SplitString(sz,"\t","\n");
				sv.DeleteToText(sz);
				g_stRotate.BuildHash(0);
				if(g_stRotate.GetCount())
					g_bRotate=TRUE;
				else
					g_bRotate=FALSE;

				sv.Clean();
				if(g_pListBoxCycle)
					g_pListBoxCycle->GetStrings(&sv);
				sz = sv.ToText("\n");
				g_stCycle.Reset();
				g_stCycle.SplitString(sz,"\t","\n");
				sv.DeleteToText(sz);
				g_stCycle.BuildHash(0);

				sv.Clean();
				if(g_pListBoxDivision)
					g_pListBoxDivision->GetStrings(&sv);
				sz = sv.ToText("\n");
				g_stDivision.Reset();
				g_stDivision.SplitString(sz,"\t","\n");
				sv.DeleteToText(sz);
				g_stDivision.M3QSort(0,0,1);
				g_stDivision.BuildHash(0);

				sv.Clean();
				if(g_pListBoxNOC)
					g_pListBoxNOC->GetStrings(&sv);
				sz = sv.ToText("\n");
				g_stNOC.Reset();
				g_stNOC.SplitString(sz,"\t","\n");
				sv.DeleteToText(sz);
				g_stNOC.M3QSort(0,0,1);
				g_stNOC.BuildHash(0);

				if(g_bWaves && g_pListBoxWaves){
					g_pListBoxWaves->GetStrings(&sv);
					sz = sv.ToText("\n");
					CStringTable stWaves(sz,"\t","\n");
					sv.DeleteToText(sz);
					int i;
					for(i=0;i<stWaves.GetCount() && i<WAVE_COLORS_NUM;i++){
						if(*stWaves[i][0]=='H')
							g_WaveColors[i].nType=0;
						else if(*stWaves[i][0]=='S')
							g_WaveColors[i].nType=1;
						else if(*stWaves[i][0]=='B')
							g_WaveColors[i].nType=2;
						else if(*stWaves[i][0]=='W')
							g_WaveColors[i].nType=3;
						g_WaveColors[i].nPeriod = atoi(stWaves[i][1]);
						g_WaveColors[i].nStart = atoi(stWaves[i][2]);
						g_WaveColors[i].bLast=0;
					}
					g_WaveColors[i].bLast=1;
				}
				if(g_pListBoxLongWaves){
					g_pListBoxLongWaves->GetStrings(&sv);
					sz = sv.ToText("\n");
					CStringTable stWaves(sz,"\t","\n");
					sv.DeleteToText(sz);
					int i;
					for(i=0;i<stWaves.GetCount() && i<WAVE_COLORS_NUM;i++){
						CStringTable stCol(stWaves[i][0],"",",");
						g_LongWaveColors[i].col = RGB(atoi(stCol[0][0]),atoi(stCol[1][0]),atoi(stCol[2][0]));
						g_LongWaveColors[i].nPeriod = atoi(stWaves[i][1]);
						g_LongWaveColors[i].percent = atoi(stWaves[i][2]);
						g_LongWaveColors[i].bLast=0;
					}
					g_LongWaveColors[i].bLast=1;
				}
				else
					g_LongWaveColors[0].bLast=1;

				int i;
				for(i=0;i<g_stParts.GetCount();i++)
					if(!atoi(g_stParts[i][1])){
						SetFocus(GetDlgItem(hWnd,IDC_LIST1));
						return MessageBox(hWnd,"Speed cannot be zero","Error",MB_OK|MB_ICONSTOP);
					}
				g_nFPS = GetDlgItemInt(hWnd,IDC_EDIT10,NULL,FALSE);
				g_nMaxFrames = GetDlgItemInt(hWnd,IDC_EDIT9,NULL,FALSE);

				g_bRunning=TRUE;
				SetDlgItemText(hWnd,IDOK,"Stop");
				DWORD dw;
				CloseHandle(CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ThRun,(LPVOID)GetDlgItem(hWnd,IDC_STATUS),0,&dw));
			}
			else
				g_bStop=TRUE;
		}
		else if(wParam==IDC_BUTTON6 || wParam==IDC_BUTTON11 || wParam==IDC_BUTTON15 || wParam==IDC_BUTTON19 || wParam==IDC_BUTTON25){
			int nEditID = IDC_EDIT2;
			if(wParam==IDC_BUTTON11)
				nEditID = IDC_EDIT14;
			if(wParam==IDC_BUTTON15)
				nEditID = IDC_EDIT16;
			if(wParam==IDC_BUTTON19)
				nEditID = IDC_EDIT18;
			if(wParam==IDC_BUTTON25)
				nEditID = IDC_EDIT20;
			RECT r;
			GetWindowRect(GetDlgItem(hWnd,wParam),&r);
			HMENU hMen = CreatePopupMenu();
			AppendMenu(hMen,MF_STRING,1,"First");
			AppendMenu(hMen,MF_STRING,2,"Last");
			AppendMenu(hMen,MF_STRING,3,"1/2");
			AppendMenu(hMen,MF_STRING,4,"3/4");
			AppendMenu(hMen,MF_STRING,5,"7/8");
			AppendMenu(hMen,MF_STRING,6,"15/16");
			AppendMenu(hMen,MF_STRING,7,"31/32");
			AppendMenu(hMen,MF_STRING,8,"63/64");
			AppendMenu(hMen,MF_STRING,9,"From file name number...");
			int rc = TrackPopupMenu(hMen,TPM_LEFTALIGN|TPM_RETURNCMD,r.left,r.bottom,0,hWnd,NULL);
			DestroyMenu(hMen);
			if(rc==1)
				SetDlgItemInt(hWnd,nEditID,0,FALSE);
			else if(rc==2)
				SetDlgItemInt(hWnd,nEditID,g_nFiles-1,FALSE);
			else if(rc==3)
				SetDlgItemInt(hWnd,nEditID,g_nFiles/2,FALSE);
			else if(rc==4)
				SetDlgItemInt(hWnd,nEditID,3*g_nFiles/4,FALSE);
			else if(rc==5)
				SetDlgItemInt(hWnd,nEditID,7*g_nFiles/8,FALSE);
			else if(rc==6)
				SetDlgItemInt(hWnd,nEditID,15*g_nFiles/16,FALSE);
			else if(rc==7)
				SetDlgItemInt(hWnd,nEditID,31*g_nFiles/32,FALSE);
			else if(rc==8)
				SetDlgItemInt(hWnd,nEditID,63*g_nFiles/64,FALSE);
			else if(rc==9){
				int n = DialogBoxParam(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_DIALOG4),hWnd,NumProc,0);
				n = g_nFiles - n;
				if(n<0)
					return MessageBox(hWnd,"Number not in the range of key-frames","Error",MB_OK|MB_ICONSTOP);
				SetDlgItemInt(hWnd,nEditID,n,FALSE);
			}
		}
		else if(wParam==IDC_CHECK2){
			if(!SendDlgItemMessage(hWnd,IDC_CHECK2,BM_GETCHECK,0,0) && MessageBox(hWnd,"Are you sure you want to turn off the display of the Zoom?\n\nOne of the fascinating things with Mandelbrot fractals is that they are truly infinite.\nAnother fascinating thing is that the patterns of the path are repeating every half distance to a Minibrot. The connection between the zoom level and the pattern will not be as clear with this feature turned off. You may proceed if you want, but I recommend you to keep the display of the zoom turned on","What??",MB_YESNO)==IDNO)
				SendDlgItemMessage(hWnd,IDC_CHECK2,BM_SETCHECK,1,0);
			else if(SendDlgItemMessage(hWnd,IDC_CHECK2,BM_GETCHECK,0,0))
				MessageBox(hWnd,"Thanks for your wise decision","Thanks",MB_OK);
			EnableWindow(GetDlgItem(hWnd,IDC_BUTTON7),SendDlgItemMessage(hWnd,IDC_CHECK2,BM_GETCHECK,0,0));
		}
		else if(LOWORD(wParam)==IDC_EDIT7 && HIWORD(wParam)==EN_CHANGE){
			int nX = GetDlgItemInt(hWnd,IDC_EDIT7,NULL,0);
			int nY = nX*360/640;
			SetDlgItemInt(hWnd,IDC_EDIT8,nY,0);
			int nS = nX*nY;
			int nFramesPerMovie = 1037000000/(nS?nS:1);
			SetDlgItemInt(hWnd,IDC_EDIT9,nFramesPerMovie,FALSE);
		}
		else if(LOWORD(wParam)==IDC_EDIT10 && HIWORD(wParam)==EN_CHANGE)
			GetMovieLength(hWnd,g_nFiles,GetDlgItemInt(hWnd,IDC_EDIT10,NULL,FALSE));
		else if(wParam==IDC_BUTTON5)
			return MessageBox(hWnd,"2013-2014 Karl Runmo version 1.24","About Key Frames Movie Maker",MB_OK);
		else if(wParam==IDC_BUTTON7){
			CHOOSEFONT cf={sizeof(CHOOSEFONT)};
			LOGFONT lfFont={0};
			strcpy(lfFont.lfFaceName,g_szFontName);
			cf.hwndOwner=hWnd;
			cf.lpLogFont = &lfFont;
			cf.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;
			if(ChooseFont(&cf)){
				strcpy(g_szFontName,lfFont.lfFaceName);
				SetDlgItemText(hWnd,IDC_EDIT13,g_szFontName);
			}
		}

	}
	else if(uMsg==WM_USER+11){
		g_bRunning=FALSE;
		g_bStop=0;
		SetDlgItemText(hWnd,IDOK,"Start");
	}
	if(g_pListBoxSpeed){
		int nRet = g_pListBoxSpeed->ProcessMessage(hWnd,uMsg,wParam,lParam);
		if(uMsg==WM_COMMAND && (wParam==IDC_BUTTON2 || wParam==IDC_BUTTON3 || wParam==IDC_BUTTON4))
			GetMovieLength(hWnd,g_nFiles,GetDlgItemInt(hWnd,IDC_EDIT10,NULL,FALSE));
	}
	if(g_pListBoxRotation)
		g_pListBoxRotation->ProcessMessage(hWnd,uMsg,wParam,lParam);
	if(g_pListBoxCycle)
		g_pListBoxCycle->ProcessMessage(hWnd,uMsg,wParam,lParam);
	if(g_pListBoxDivision)
		g_pListBoxDivision->ProcessMessage(hWnd,uMsg,wParam,lParam);
	if(g_pListBoxNOC)
		g_pListBoxNOC->ProcessMessage(hWnd,uMsg,wParam,lParam);
	if(g_pListBoxWaves)
		g_pListBoxWaves->ProcessMessage(hWnd,uMsg,wParam,lParam);
	if(g_pListBoxLongWaves)
		g_pListBoxLongWaves->ProcessMessage(hWnd,uMsg,wParam,lParam);
	return 0;
}
int Test()
{
	int i;
	int nPeriod=200;
	HDC hDC = GetDC(NULL);
	MoveToEx(hDC,0,0,NULL);
	for(i=0;i<1600;i++){
		if((i/(nPeriod*2))%2==0)
			continue;
		double g = 1 - (cos((pi*i)/nPeriod)/2+.5);
		LineTo(hDC,i,g*300);
	}
	ReleaseDC(NULL,hDC);
	return 0;
}
#define INTEGERS 4
int add64(unsigned __int64 &loWord, unsigned __int64 &loAdd)
{
    loWord += loAdd;
    return (loWord < loAdd); // test_and_add_carry                                                                                                               
}
unsigned __int64 mul64(unsigned __int64 u, unsigned __int64 v, unsigned __int64& c)
{
    unsigned __int64 u1 = (u & 0xffffffff);
    unsigned __int64 v1 = (v & 0xffffffff);
    unsigned __int64 t = (u1 * v1);
    unsigned __int64 w3 = (t & 0xffffffff);
    unsigned __int64 k = (t >> 32);
    
    u >>= 32;
    t = (u * v1) + k;
    k = (t & 0xffffffff);
    unsigned __int64 w1 = (t >> 32);
    
    v >>= 32;
    t = (u1 * v) + k;
    k = (t >> 32);
    
    c = (u * v) + w1 + k;
    return (t << 32) + w3;
}

int Test1()
{
	char *szVal = "0.921120394324823491239443292312312387613298787123498714329321874214312331776567";
	char szTmp[256+INTEGERS*64];
	strcpy(szTmp,szVal);
	int r=0, q=0;
	int k;
	int c=0;
	unsigned __int64 res[INTEGERS]={0};
	while(q<INTEGERS){
		while(r<64 + q*64){
			k=strlen(szTmp);
			while(k && szTmp[k-1]=='0')
				k--;
			for(k--;k>=0;k--){
				if(szTmp[k]=='.')
					continue;
				int r = (szTmp[k]-'0')*2 + c;
				c = r/10;
				r-=c*10;
				szTmp[k]=r+'0';
			}
			res[q] = (res[q]<<1) + szTmp[0]-'0';
			szTmp[0]='0';
			r++;
		} 
		q++;
	}
	szTmp[0]='0';
	szTmp[1]=0;
	for(q=INTEGERS-1;q>=0;q--){
		int mask=0;
		while(mask<64){
			int r = (res[q]>>mask) & 1;
			int a;
			int c=0;
			if(r)
				c=5;
			for(a=0;szTmp[a];a++){
				int nc = (szTmp[a]-'0')&1;
				szTmp[a] = (szTmp[a]-'0')/2 + c + '0';
				if(nc)
					c=5;
				else
					c=0;
			}
			if(c){
				szTmp[a]='5';
				a++;
				szTmp[a]=0;
			}
			mask++;
		}
	}
	for(k=0;szTmp[k] && szVal[k+2];k++)
		if(szTmp[k]!=szVal[k+2])
			break;
	sprintf(szTmp,"%s at:%d, szVal=%d",szVal[k+2]?"Diff":"End",k,strlen(szVal)-2);
	return MessageBox(NULL,szTmp,"Test2",MB_OK);
}
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE,LPSTR,int)
{
//	return Test1();
	g_WaveColors[0].bLast=1;
//	InitMultiWave();
	g_hMutex = CreateMutex(NULL,0,NULL);
//	return Test();
//	return DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),NULL,MainProc,0);
	return DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_DIALOG2),NULL,KeyFramesProc,0);
}